/**
 * 从相册批量上传图片
 */
var MediaManager = {
	/**
	 *  七牛空间域名
	 */
	QINIU_URL: QINIU_PREFIX,
	/**
	 * 最大上传文件数
	 */
	MAX_FILE_NUM: 20,

	uploadingCount: 0,
	/**
	 * 七牛上传器
	 */
	qiniuUploader: null,
	/**
	 * 上传控件
	 */
	uploadCtrl: document.getElementById("txtUpload"),
	/*
	 * 附件列表
	 */
	attachmentList: document.getElementById('attachmemtList'),
	/**
	 * 已上传图片
	 */
	arrUploadedImg: [],
	/**
	 * 初始化
	 */
	init: async function() {
		//上传图标点击事件监听
		document.getElementById("btnAdd").addEventListener('tap', async function() {
			//android,判断是否有授权相册权限
			if(mui.os.android){
				var result = await requestAndroidPermission('android.permission.READ_EXTERNAL_STORAGE')
				console.log('a:',result);
				//没有授权跳转到权限页面
				if(result!=1){
					alert('请打开相册权限(或读写权限)！');
					//前往app的权限页面
					gotoAppPermissionSetting();
				}
				//已获得授权
				else if(result==1){
					MediaManager.upload();
				}
			}
			//IOS,不判断权限
			else{
				MediaManager.upload();
			}
		});
		MediaManager.initQiniuToken();
	},
	/**
	 * 初始化七牛令牌
	 */
	initQiniuToken: function() {
		var token_url = API_URL + "/Complain/GetQiniuToken";
		$ajax(token_url, {
			success: function(data) {
				// var token = eval("(" + data + ")");
				MediaManager.initQiniu(data.uptoken);
			}
		});
	},
	pickImages:function(){
		//已经上传图片数量
		var countbefore = MediaManager.attachmentList.childElementCount;
		if (countbefore >= MediaManager.MAX_FILE_NUM) {
			mui.toast('最多选择' + MediaManager.MAX_FILE_NUM + '张图片')
		}
		plus.gallery.pick(function(e) {
			console.log(e)
			document.getElementById("btnSubmit").setAttribute("disabled", true); //开始上传图片，禁用提交投诉按钮
			uploadingCount = e.files.length;
			for (var i in e.files) {
				var path=e.files[i];
				MediaManager.dImage(path);
				console.log(path);
				
			}
		}, function(e) {
			console.log("取消选择图片");
		}, {
			filter: "image", //系统相册选择器中可选择的文件类型 "image" , "video" , "none"
			multiple: true, //是否支持多选
			maximum: MediaManager.MAX_FILE_NUM - (countbefore - 1), //最多选择的文件数量，上面设置了全局变量
			system: true, //是否使用系统文件选择界面，iOS下无效
			onmaxed: function() { //超出选择最大文件数时触发 
				mui.toast('最多选择' + MediaManager.MAX_FILE_NUM + '张图片')
			}
		});
	},
	uploadToServer:function(file,fileName){
		var reader = new plus.io.FileReader();
		reader.onloadend = function(e) { 
			//读取文件内容 dataurl 转化为BLOB对象  
			var blob = MediaManager.toBlob(e.target.result);
			var newfile = new File([blob], fileName);
			
			if(MediaManager.checkFile(fileName,file)){
				upLoad(newfile,fileName);
			}
		};
		reader.readAsDataURL(file);
		
		var upLoad = function(newfile,fileName){
			console.log('newfile:',newfile.type)
			var fd=new FormData();
			fd.append('file',newfile);
			fd.append('fileName',fileName);
			fd.append('fileSource',"complain");
			fd.append('fileTarget',"complain");
			console.log('file101',fd.getAll('file'))
			$.ajax({
				type: 'POST',
				data:fd,
				url: API_URL+'/Upload/UpImage',
				//noSendMcode:true,
				contentType:false,
				processData:false,
				dataType: "json",
				timeout: 10000,
				beforeSend: function(xhr) {
					var access_token=AccessToken.get()
					xhr.setRequestHeader("Authorization", "Bearer " + access_token);
					
				},
				success: function(res){
					console.log('success',res.Message);
					if(res.Success){
						MediaManager.handleUploaded(res.upFileInfos[0].fileName);
					}else{
						mui.alert(res.Message);
					}
				}
			})
			// mui.ajax(
			// API_URL + '/Upload/UpImage',
			// {
			// 	data:fd,
			// 	type: 'POST',
			// 	// url: API_URL+'/Upload/UpImage',
			// 	//noSendMcode:true,
			// 	contentType:false,
			// 	processData:false,
			// 	beforeSend: function(xhr) {
			// 			var access_token=AccessToken.get()
			// 			xhr.setRequestHeader("Authorization", "Bearer " + access_token);
						
			// 		},
			// 	success: function(res){
			// 		console.log('success',res.Message);
			// 		if(res.Success){
			// 			MediaManager.handleUploaded(res.upFileInfos[0].fileName);
			// 		}else{
			// 			mui.alert(res.Message);
			// 		}
			// 	}
			// })
			
		}
	},
	//路径转化为BLOB对象
	toBlob: function(dataurl) {
		var arr = dataurl.split(','),
			mime = arr[0].match(/:(.*?);/)[1],
			bstr = atob(arr[1]),
			n = bstr.length,
			u8arr = new Uint8Array(n);
		while (n--) {
			u8arr[n] = bstr.charCodeAt(n);
		}
		return new Blob([u8arr], {
			type: mime
		});
	},
	dImage:function(path){
		console.log('dImage')
		plus.io.resolveLocalFileSystemURL(path, function(entry) {
			entry.file(function(file) {
				console.log(file.type)
				if(file.type=='image/heic'){
					MediaManager.uploadToServer(file, entry.name);
				}
				//大于300kb
				else if(file.size>30000 && mui.os.android){
					console.log('压缩')
					MediaManager.dealImage(path,{},function(res){
						console.log(143)
						var blob = MediaManager.toBlob(res);
						console.log('TOBLOG',res)
						var newfile = new File([blob], entry.name);
						MediaManager.uploadFile(newfile.name, newfile);
					})
				}
				else{
					console.log('不压缩')
					
					var reader = new plus.io.FileReader();
					reader.onloadend = function(e) { 
						//读取文件内容 dataurl 转化为BLOB对象  
						var blob = MediaManager.toBlob(e.target.result);
						var newfile = new File([blob], entry.name);
						MediaManager.uploadFile(newfile.name, newfile);
					};
					reader.readAsDataURL(file);
				}
			});
		})
	},
	//压缩处理图片
	dealImage: function(path, obj, callback) {
		var img = new Image();
		img.crossOrigin = "anonymous";
		img.src = path;
		img.onload = function() {
			console.log('onload')
			var that = this;
			// 默认按比例压缩
			var w = that.width,
				h = that.height;
			var quality = 0.3; // 默认图片质量0.1-1
			//生成canvas
			var canvas = document.createElement('canvas');
			var ctx = canvas.getContext('2d');
			// 创建属性节点
			var anw = document.createAttribute("width");
			anw.nodeValue = w;
			var anh = document.createAttribute("height");
			anh.nodeValue = h;
			canvas.setAttributeNode(anw);
			canvas.setAttributeNode(anh);
			console.log(184)
			ctx.drawImage(that, 0, 0, w, h);
			// 图像质量
			if (obj.quality && obj.quality <= 1 && obj.quality > 0) {
				quality = obj.quality;
			}
			// quality值越小，所绘制出的图像越模糊
			var base64 = canvas.toDataURL('image/jpeg', quality);
			// 回调函数返回base64的值
			callback(base64);
		}
		img.onerror = function(e){
			console.log('',e)
		}
	},
	// 上传成功后处理现实
	handleUploaded:function(fileName){
		var imgUrl = MediaManager.QINIU_URL + fileName;
		var saveImgUrl = fileName;
		var thumbUrl = imgUrl + "?imageView2/1/w/100/h/100";
		var count = MediaManager.attachmentList.childElementCount;
		for (var i = 1; i < count; i++) {
			var node = MediaManager.attachmentList.childNodes[i];
			if (node.id == "") {
				node.querySelector('img').setAttribute('src', thumbUrl);
				node.querySelector('img').setAttribute('uri', imgUrl);
				node.id = saveImgUrl;
				node.querySelector('span').id = saveImgUrl;
				MediaManager.arrUploadedImg.push(saveImgUrl);
				console.log(MediaManager.arrUploadedImg);
				break;
			}
		}
		//var node = MediaManager.attachmentList.childNodes[count - 1];
		//node.querySelector('img').setAttribute('src', thumbUrl);
		//node.querySelector('img').setAttribute('uri', imgUrl);
		//MediaManager.arrUploadedImg.push(saveImgUrl);
		if (uploadingCount >= 2) {
			uploadingCount = uploadingCount - 1;
			document.getElementById("btnSubmit").setAttribute("disabled", true)
			//document.getElementById("btnSubmit").style.display="none";
		} else if (uploadingCount = 1) {
			uploadingCount = uploadingCount - 1;
			document.getElementById("btnSubmit").removeAttribute("disabled"); //上传完成，启用提交按钮
			//document.getElementById("btnSubmit").style.display="";
			mui.toast('附件上传完毕！请继续！');
		}
		console.log(uploadingCount)
	},
	/**
	 * 初始化七牛
	 * 
	 * @param {Object} qiniuToken 七牛令牌
	 */
	initQiniu: function(qiniuToken) {
		MediaManager.qiniuUploader = Qiniu.uploader({
			runtimes: 'html5',
			browse_button: 'btnUpload',
			container: 'container',
			drop_element: 'container',
			max_file_size: '10mb',
			dragdrop: false,
			chunk_size: '4mb',
			uptoken: qiniuToken,
			multi_selection: false,
			unique_names: true, // 默认 false，key为文件名。若开启该选项，SDK为自动生成上传成功后的key（文件名）。
			domain: MediaManager.QINIU_URL,
			auto_start: true,
			init: {}
		});
		MediaManager.qiniuUploader.bind('FilesAdded', function(up, files) {
			var count = MediaManager.attachmentList.childElementCount;
			//MediaManager.attachmentList.childNodes[count - 2].id = files[0].id;
			MediaManager.uploadCtrl.value = '';
			mui.toast('正在上传附件...请稍等');
		});
		MediaManager.qiniuUploader.bind('FileUploaded', function(up, file, info) {
			MediaManager.handleUploaded(file.target_name);
		});
	},
	/**
	 * 上传
	 */
	upload: function() {
		if (MediaManager.attachmentList.childElementCount > MediaManager.MAX_FILE_NUM) {
			return mui.toast('附件最多只能有' + MediaManager.MAX_FILE_NUM + '个！');
		}
		MediaManager.pickImages();

	},
	checkFile:function(fileName, file){
		if (fileName) {
			if (MediaManager.attachmentList.childElementCount > MediaManager.MAX_FILE_NUM) {
				mui.toast('附件最多只能有' + MediaManager.MAX_FILE_NUM + '个！');
				return false;
			}
			//var attachment = MediaManager.uploadCtrl.files[0];
			var li = document.createElement('li');
			var imageReg = new RegExp("(.jpg|.png|.bmp|.jpeg|.webp|.gif|.heic)$", 'i');
			if (imageReg.test(fileName)) {
				var img = document.createElement('img');
				//var imgUrl = window.URL.createObjectURL(fileName);
				var imgUrl = fileName;
				img.src = 'images/loading.gif';
				img.setAttribute('onclick', 'MediaManager.show(this);');
		
				var imgWrapper = document.createElement('div');
				imgWrapper.classList.add('img-wrapper');
				imgWrapper.appendChild(img);
				li.appendChild(imgWrapper);
				//添加删除按钮
				var span = document.createElement("span");
				span.className = "del";
				span.setAttribute("uri", imgUrl);
				span.innerHTML = "×";
				span.addEventListener("tap", function(that) {
					mui.confirm("真的要删除吗？", "温馨提示", ['是', '否'], function(e) {
						if (e.index == 0) {
							MediaManager.removeImg(that.target.parentElement.id);
						}
					});
					return false;
				});
				li.appendChild(span);
				MediaManager.attachmentList.insertBefore(li, MediaManager.attachmentList.lastElementChild);
				return true;
			} else {
				mui.toast(fileName + ':类型不支持或文件名太长');
				return false;
			} 
		}
		return false;
	},
	/**
	 * 上传文件
	 * 
	 */
	uploadFile: function(fileName, file) {
		//var fileName = MediaManager.uploadCtrl.value.toLowerCase();
		if(MediaManager.checkFile(fileName,file)){
			MediaManager.qiniuUploader.addFile(file);
		}
	},
	/**
	 * 显示多媒体
	 * 
	 * @param {Object} li 
	 */
	show: function(that) {
		var imgUrl = that.getAttribute('uri');
		plus.nativeUI.previewImage([imgUrl])
		// MUIPopover.autoPopover({
		// 	domSource: img.parentElement
		// });
	},
	/**
	 * Clear Img
	 * 
	 * @param {Object} url
	 */
	removeImg: function(url) {
		console.log(MediaManager.arrUploadedImg);
		var newArrImg = [];
		var idx = 0;
		for (var i = 0; i < MediaManager.arrUploadedImg.length; i++) {
			if (MediaManager.arrUploadedImg[i].indexOf(url) < 0) {
				newArrImg.push(MediaManager.arrUploadedImg[i]);
			} else {
				idx = i;
			}
		}
		MediaManager.arrUploadedImg = [];
		MediaManager.arrUploadedImg = newArrImg;
		//删除图片
		var liNode = document.getElementById('attachmemtList').getElementsByTagName("li");
		MediaManager.attachmentList.removeChild(liNode[idx]);
	},
	/**
	 * 删除所有图片
	 * 
	 * @param {Object} url
	 */
	removeAll: function() {
		for (var i = 0; i < MediaManager.arrUploadedImg.length; i++) {
			MediaManager.removeImg(MediaManager.arrUploadedImg[i]);
		}
	}
};
