var memcode = window.localStorage.getItem("memcode");
var pageIndex = 1;
var pageSize = 15;
var datalist = [];
var invoiceIndex = 0; //查看的发票

mui.init({
	swipeBack: false, //启用右滑关闭功能
	beforeback: function() {
		var parent = plus.webview.currentWebview().opener();
		//GetInvoiceTitleList();
		// mui.fire(parent, 'refresh');
		return true;
	},
	pullRefresh: {
		container: ".mui-scroll-wrapper", //待刷新区域标识，querySelector能定位的css选择器均可，比如：id、.class等
		up: {
			height: 50, //可选.默认50.触发上拉加载拖动距离
			auto: false, //可选,默认false.自动上拉加载一次
			contentrefresh: "正在加载...", //可选，正在加载状态时，上拉加载控件上显示的标题内容
			contentnomore: '没有更多数据了', //可选，请求完毕若没有更多数据时显示的提醒内容；
			callback: GetList //必选，刷新函数，根据具体业务来编写，比如通过ajax从服务器获取新数据；
		}
	}
});

//阻尼系数
var deceleration = mui.os.ios ? 0.003 : 0.0009;

mui('.mui-scroll-wrapper').scroll({
	bounce: true,
	indicators: true, //是否显示滚动条
	deceleration: deceleration
});

function isMore(total) {
	if (pageIndex * pageSize >= total) {
		mui('.mui-scroll-wrapper').pullRefresh().endPullupToRefresh(true);
	} else {
		mui('.mui-scroll-wrapper').pullRefresh().endPullupToRefresh(false);
		pageIndex++;
	}
}

function resetPullUp(){
	mui('.mui-scroll-wrapper').pullRefresh().refresh(true);
	pageIndex = 1;
	document.getElementById("ulOrder").innerHTML = "";
	mui('.mui-scroll-wrapper').scroll().scrollTo(0,0,0);//100毫秒滚动到顶
}

function GetList() {
	$ajax(API_URL + '/MemInvoice/GetInvoice', {
		data: {
			Memcode: memcode,
			PageIndex: pageIndex,
			PageSize: pageSize
		},
		dataType: 'json', //服务器返回json格式数据
		type: 'Get', //HTTP请求类型
		timeout: 10000, //超时时间设置为10秒；
		success: function(res) {
			isMore(res.Total);
			if (res.Total > 0) {
				datalist = res.Rows;
				ShowList(datalist);
			} else {
				mui.toast(res.Msg);
			}
		}
	});
}

function ShowList(data) {
	let htmlStr = ``;
	for (var i in data) {
		var invoiceTypeStr = "";
		var checkStr = `<button id="btnCheck" type="button" onclick="mui('#sheet1').popover('toggle');invoiceIndex=` +
			i +
			`" class="mui-btn mui-btn-red">查看发票</button>`;
			
		if (data[i].InvoiceType != 1) {
			invoiceTypeStr = '<span class="Special">专票</span>';
		}
		if(data[i].State==1 ||data[i].State==21){
			invoiceTypeStr+='<span class="Default">已申请</span>';
		}
		else if(data[i].State==2){
			invoiceTypeStr+='<span class="Green">已开票</span>';
		}
		else{
			invoiceTypeStr+='<span class="Special">不通过</span>';
		}
		htmlStr += `
			<div class="Row">
				<div class="RowTitle">
					<span class="spanOrdernum">` + data[i].Invoicenum + `</span>` + invoiceTypeStr + `
					<span style="float: right;">开票金额：￥` + data[i].InvoiceAmount + `</span>
				</div>
				<div class="RowContent">
					<span style="font-size: 0.875rem;">` + data[i].InvoiceTitle + `</span>
					<span style="color: #808080;font-size: 0.75rem;">` + data[i].TaxNum + `</span>
					<span style="line-height: 1.2rem;font-size: 0.875rem;"><br/>订单金额：￥` + data[i].ProductAmount + `</span>
					<span style="line-height: 1.2rem;font-size: 0.875rem;"><br/>服务费：￥` + data[i].ServiceAmount + `</span>
				</div>
				<div class="RowContent" style="text-align: right;">
					<button id="btnDetail" type="button" onclick="OpenWindowInIframeNotitle('invoice_item.html?mainId=` + data[i].Id + `')" class="mui-btn mui-btn-red">查看明细</button>
					` + checkStr + `
				</div>
			</div>
		`;
	}
	htmlStr += '<div style="height:53px;width:100%"></div>';
	var oldHtml = document.getElementById("ulOrder").innerHTML;
	document.getElementById("ulOrder").innerHTML = oldHtml+htmlStr;
	// document.getElementById("content").innerHTML = htmlStr;
}

//预览发票图片
function CheckPic() {
	if (datalist[invoiceIndex].State != 2) {
		checkInvoice(datalist[invoiceIndex].Invoicenum, datalist[invoiceIndex].Id)
	} else {
		OpenWindowInIframe("http://" + datalist[invoiceIndex].PictureUrl)
	}
}

//在线预览PDF
function CheckPdf() {
	console.log(invoiceIndex)
	if (datalist[invoiceIndex].State != 2) {
		checkInvoice(datalist[invoiceIndex].Invoicenum, datalist[invoiceIndex].Id)
	} else {
		reg = new RegExp("/", "g");
		var url = datalist[invoiceIndex].PdfUrl.replace(reg, '\/')
		OpenWindowInIframe('../js/PDF_JS/web/viewer.html?file=' + url);
	}
}

//跳转到浏览器下载PDF
function DownloadPdf() {
	window.parent.mui.plusReady(function() {
		console.log('download')
		window.parent.plus.runtime.openURL(datalist[invoiceIndex].PdfUrl);
	});
}

function checkInvoice(invoicenum, invoiceid) {
	var issuccess = false;
	$ajax(API_URL + '/MemInvoice/GetInvoiceResult', {
		data: {
			invoiceNum: invoicenum,
			invoiceId: invoiceid,
		},
		dataType: 'json', //服务器返回json格式数据
		type: 'post', //HTTP请求类型
		timeout: 10000, //超时时间设置为10秒；
		success: function(res) {
			if (res.ErrorCode === 1) {
				mui.toast(res.Msg);
				if (res.ErrorCode == 1) {
					if (res.data.State == 2) {
						if (res.data.PictureUrl) {
							openExtWindow('https://' + res.data.PictureUrl);
							OpenWindowInIframe("http://" + res.data.PictureUrl)
						} else {
							checkInvoice(invoicenum, invoiceid);
						}
					} else {
						mui.alert("正在处理，请耐心等待！");
					}
				} else {
					mui.alert("查询失败，请稍后重试！");
				}
			} else {
				issuccess = false;
				mui.toast(res.Msg);
			}
		}
	});
	return issuccess;
}

function OpenWindowInIframe(url) {
	parent.mui.openWindow({
		id: 1,
		url: url,
		styles: {
			backButtonAutoControl: "hide",
			titleNView: { // 窗口的标题栏控件
				autoBackButton: true,
				titleText: '发票预览', // 标题栏文字,当不设置此属性时，默认加载当前页面的标题，并自动更新页面的标题
				titleColor: "#FFFFFF", // 字体颜色,颜色值格式为"#RRGGBB",默认值为"#000000"
				titleSize: "17px", // 字体大小,默认17px
				backgroundColor: "#E87884", // 控件背景颜色,颜色值格式为"#RRGGBB",默认值为"#F7F7F7"
			},
		},
		waiting: {
			autoShow: false, //自动显示等待框，默认为true
		}
	});
}

//在iframe中打开页面
function OpenWindowInIframeNotitle(url) {
	parent.mui.openWindow({
		id: 1,
		url: url,
		styles: {
			backButtonAutoControl: "hide",
		},
		waiting: {
			autoShow: false, //自动显示等待框，默认为true
		}
	});
}

if (IS_APP) {
	window.parent.mui.plusReady(function() {
		GetList();
	});
} else {
	GetList();
}

window.addEventListener('refreshInvoice', function(e) {
	console.log("刷新refreshInvoice")
	GetList();
});
