var memcode = window.localStorage.getItem("memcode");
var txtStartDate = document.getElementById("starttime");
var txtEndDate = document.getElementById("endtime");
var dataArr = [];

mui.init({
	swipeBack: false //启用右滑关闭功能
});

function initData() {
	if (memcode == "" || memcode == null) {
		return mui.openWindow("login.html"); //yjp修改
	}
	var date = new Date();
	var startDate = RDateUtil.addDate(date, -7);
	txtStartDate.value = RDateUtil.formatDate(startDate, "yyyy-MM-dd");
	txtEndDate.value = RDateUtil.formatDate(date, "yyyy-MM-dd");
	searchData();
}

function getCanComplain(status){
	let text="";
	if(status==true){
		text="";
	}else{
		text="<span class='right'>已过期</span>";
	}
	return text;
}

function searchData() {

	if (txtStartDate.value == "") {
		mui.alert("请选择开始日期", "", "", null, "div");
		return false;
	}
	if (txtEndDate.value == "") {
		mui.alert("请选择结束日期", "", "", null, "div");
		return false;
	}
	$ajax(API_URL + '/Ordercommit/GetVListByUserCode', {
		data: {
			startTime: txtStartDate.value,
			endTime: txtEndDate.value,
			memCode: memcode,
			pageSize: 100
		},
		dataType: 'json', //服务器返回json格式数据
		type: 'get', //HTTP请求类型
		timeout: 10000, //超时时间设置为10秒；
		headers: {
			'Content-Type': 'application/json'
		},
		success: function(data) {
			var objs = data.Rows;
			var html = '';
			if (objs.length == 0) {
				html = '<li class="mui-table-view-cell">没有找到相关信息！</li>';
			} else {
				dataArr = objs;
				for (var i = 0; i < objs.length; i++) {
					var order = objs[i];
					html +=
						'<li class="mui-table-view-cell"><a href="javascript:;" class="mui-navigate-right tra_a" data-index="'+i+'" >' +
						'<div class="tra_title"><i>' + order.Commitedate.substring(0, 10) + '</i><span class="t_ul_span">' + order.Ordernum +
						'</span><span>数量:' + order.Ordercount + '</span><span>金额:￥' + order.Ordermoney + '</span>'+
						getCanComplain(order.Cancomplain)+
						'</div></a></li>';
				}
			}
			document.getElementById("spanTotal").innerHTML = data.Total;
			document.getElementById("ulOrder").innerHTML = html;
		}
	})
}

function getHourBySsite(sSite) {
	switch (sSite) {
		case "斗南鲜花站上午":
			return 12;
		case "斗南鲜花站下午":
			return 17;
		case "缤纷优选鲜花":
			return 24;
		case "缤纷总网":
			return 24;
		default:
			return 24
	}
}

function saveDeliveryTime(data){
	
	$ajax(API_URL+'/Ordercommit/SaveDeliveryTime',{
		data:data,
		dataType:'json',//服务器返回json格式数据
		type:'post',//HTTP请求类型
		timeout:10000,//超时时间设置为10秒；
		success:function(res){
			if(res.Success){
				mui.toast(res.Msg);
				mui.later(function(){
					searchData();
				},500);
			}else{
				mui.toast(res.Msg);
			}
		},
		error:function(xhr,type,errorThrown){
			mui.toast(xhr.status +","+ xhr.statusText);
		},
		beforeSend:function(){
			if(IS_APP){
				plus.nativeUI.showWaiting();
			}
		},
		complete:function(){
			if(IS_APP){
				plus.nativeUI.closeWaiting();
			}
		}
	});
}

function initView() {
	var btns = mui('.my-text');
	btns.each(function(i, btn) {
		btn.addEventListener('tap', function() {
			var _self = this;
			if (_self.picker) {
				_self.picker.show(function(rs) {
					if (id == "starttime") {
						txtStartDate.value = rs.text;
					} else {
						txtEndDate.value = rs.text;
					}
					_self.picker.dispose();
					_self.picker = null;
				});
			} else {
				var optionsJson = this.getAttribute('data-options') || '{}';
				var options = JSON.parse(optionsJson);
				var id = this.getAttribute('id');
				options.endDate = new Date();
				_self.picker = new mui.DtPicker(options);
				_self.picker.show(function(rs) {

					if (id == "starttime") {
						txtStartDate.value = rs.text;
					} else {
						txtEndDate.value = rs.text;
					}
					_self.picker.dispose();
					_self.picker = null;
				});
			}

		}, false);
	});

	document.getElementById("btnsearch").addEventListener('tap', function() {
		searchData();
	});
	
	document.getElementById('goComplain').addEventListener('tap',function () {
	    mui.openWindow('complain_list.html');    
	})

	mui('body').on('tap', '.tra_a', function() {
		let curData = dataArr[this.dataset.index];
		let orderNum = curData.Ordernum;
		let canComplain = curData.Cancomplain;
		if(!canComplain)return mui.toast(`订单(${orderNum})已超出投诉时效！`);
		let sSite = curData.Ssite;
		let deliveryTime = curData.Deliverytime.replace(/-/g,"/");
		let saleDate = curData.Saledate;
		let jdHour = getHourBySsite(sSite); 
		let jdTime = new Date(saleDate).setHours(new Date(saleDate).getHours()+jdHour);//截单时间
		if (new Date(deliveryTime).getFullYear() == 2001 || isNaN(new Date(deliveryTime).getFullYear())) { //还没确认收货
			mui.confirm('先选择收货时间再投诉','提示',['取消','确认'],function (e) {
				if(e.index == 1){
					var dtPicker = new mui.DtPicker({
						type:'hour',
						beginDate: new Date(RDateUtil.formatDate(new Date(),"yyyy/MM/dd")+" 00:00:00"),//设置开始日期 
						endDate: new Date(),//设置结束日期 
					});
					dtPicker.show(function(selectItems) {
						let myDeliveryTime = selectItems.value +':00:00';
						//收货时间选择只能选截单时间开始往后的84小时内
						let lastTime = new Date(jdTime).setHours(new Date(jdTime).getHours() + 84);
						if(new Date(myDeliveryTime)>new Date(lastTime)){
							return mui.alert("选择的收货时间已超过投诉时效！");
						}
						if(new Date(myDeliveryTime)<=new Date(jdTime)){
							return mui.alert("选择的收货时间太早！");
						}
						let data = {
							Orderuser: memcode,
							Ordernum: orderNum,
							Deliverytime: myDeliveryTime
						};
						saveDeliveryTime(data);
					})
				}
			},'div')

		} else {
			mui.openWindow(`complain_order_detail.html?orderNum=${orderNum}`);
		}

	});
}

if (IS_APP) {
	mui.plusReady(function() {
		initView();
		initData();
	});
} else {
	initView();
	initData();
}
