mui.init({
	swipeBack: false, //启用右滑关闭功能
	beforeback: function() {
		var parent = plus.webview.currentWebview().opener();
		mui.fire(parent, 'refresh');
		return true;
	}
});
var memCode = localStorage.getItem("memcode");
var productArr=[];

function formatOrderType(orderType) {
	var strHtml = '';
	switch (orderType) {
		case 1:
			strHtml = 'PC订购';
			break;
		case 2:
			strHtml = 'PC竞购';
			break;
		case 3:
			strHtml = 'PC预订';
			break;
		case 4:
			strHtml = 'PC代购';
			break;
		case 11:
			strHtml = 'PC加单';
			break;
		case 19:
			strHtml = 'APP订购';
			break;
		case 29:
			strHtml = 'APP竞购';
			break;
		case 39:
			strHtml = 'APP预订';
			break;
		case 16:
			strHtml = '零售订购';
			break;
		case 26:
			strHtml = '零售竞购';
			break;
		case 36:
			strHtml = '零售预订';
			break;
	}
	return strHtml;
}

function getOrderInfo() {
	//订单号
	var orderNum = this.getQueryString('orderNum');

	document.getElementById("orderNum").innerHTML = orderNum;

	$ajax(API_URL + '/Ordercommit/GetListByUserCode', {
		data: {
			orderNum: orderNum,
			memCode: memCode,
			pageSize: 1000
		},
		dataType: 'json', //服务器返回json格式数据
		type: 'get', //HTTP请求类型
		timeout: 10000, //超时时间设置为10秒；
		headers: {
			'Content-Type': 'application/json'
		},
		success: function(data) {
			var objs = data.Rows;
			var html = '';
			if (objs.length == 0) {
				html = '<li class="mui-table-view-cell">没有找到相关信息！</li>';
			} else {
				productArr = objs.concat();
				for (var i = 0; i < objs.length; i++) {
					var order = objs[i];
					html += '<li class="mui-table-view-cell mui-collapse"><a class="mui-navigate-right" href="#">' +
						'<div class="tra_title"><div class="tra_left mui-ellipsis"><i>' + order.Brand + '</i><span class="t_ul_span">' + order.Name + '</span></div><div class="tra_right"><span>数量：' +
						order.Ordercount + '</span><span>金额：￥' + order.Ordermoney + '</span></div></div></a>' +
						'<div class="mui-collapse-content tra_box">' +
						'<div class="tra_title"><label>订购时间：' + order.Ordertime + '</label><label class="mui-pull-right">' + formatOrderType(order.Ordertype) +
						'</label></div>' +
						'<span class="tra_l">编码：' + order.Code + '</span><span class="tra_r">' + order.Name + '<a>' + order.Grade +
						'</a></span><br />' +
						'<span class="tra_l">颜色：' + order.Color + '</span><span class="tra_r">大类：' + order.Lclass + '</span><br />' +
						'<span class="tra_l">小类：' + order.Sclass + '</span><span class="tra_r">单价：￥' + order.Orderprice +
						'</span><br />' +
						'<span class="tra_l">订购数：' + order.Ordercount + '</span><span class="tra_r">退货数：' + order.Backcount +
						'</span><br />' +
						'<span class="tra_l">有效数：' + (order.Ordercount - order.Backcount) + '</span><span class="tra_r">订购额：￥' + order.Ordermoney + '</span><br />' +
						'<span class="tra_l">退货额：￥' + order.Backmoney + '</span><span class="tra_r">有效额：￥' + (order.Ordermoney - order.Backmoney) + '</span>'+
						'<div class="ts_div"><button type="button" class="mui-btn mui-btn-blue btn_submit" value="'+order.Ordernum+'" data-code="'+order.Code+'" data-idx="'+i+'">我要投诉</button></div>'+
						'</div></li>';
				}
			}
			document.getElementById("spanTotal").innerHTML = data.Total;
			document.getElementById("ulOrder").innerHTML = html;
		}
	});
}

function getObjFromArr(id){
	for(var i=0;i<productArr.length;i++){
		if(productArr[i].Id=id){
			return productArr[i];
		}
	}
}

function initView(){
	mui(document.body).on('tap','.btn_submit',function(){
		let orderNum = this.value;
		let code = this.dataset.code;
		let idx = Number(this.dataset.idx);
		let obj = productArr[idx];
		
		$ajax(API_URL+'/Complain/GetOrderComplainById',{
			data:{
				Ordercommitid: parseInt(obj.Id)
			},
			dataType:'json',//服务器返回json格式数据
			type:'get',//HTTP请求类型
			timeout:10000,//超时时间设置为10秒；
			success:function(res){
				if(res.Total==0){
					mui.openWindow({url:'complain_submit.html',extras:{
						orderNum: orderNum,
						orderCommitId: obj.Id,
						orderPrice: obj.Orderprice,
						code: code,
						name: obj.Name,
						color: obj.Color,
						grade: obj.Grade,
						sSite: obj.Ssite,
						orderTime: obj.Ordertime
					}});
				}else{
					mui.alert("已经投诉过了")
				}
			},
			error:function(xhr,type,errorThrown){
				
			}
		});
		
	}) 
}

function initData() {
	getOrderInfo();
}

if (IS_APP) {
	mui.plusReady(function() {
		initData();
		initView();
	});
} else {
	initData();
	initView();
}

window.addEventListener('refresh',function () {
    initData();    
})
