var IMG_HELP = (function() {
	function download_img(image_url, local_image_url, index, callback) {
		// filename:下载任务在本地保存的文件路径
		let download_task = plus.downloader.createDownload(image_url, {
			filename: local_image_url
		}, function(download, status) {
			// 下载失败,删除本地临时文件
			if (status != 200) {
				console.log('下载失败,status' + status);
				if (local_image_url != null) {
					plus.io.resolveLocalFileSystemURL(local_image_url, function(entry) {
						entry.remove(function(entry) {
							console.log("临时文件删除成功" + local_image_url);
							// 重新下载图片
							download_img(callback);
						}, function(e) {
							console.log("临时文件删除失败" + local_image_url);
						});
					});
				}
			} else {
				// 把下载成功的图片显示
				// 将本地URL路径转换成平台绝对路径
				console.log("下载成功" + local_image_url);
				var local_image_url_res = plus.io.convertLocalFileSystemURL(local_image_url);
				callback(local_image_url_res, index)
			}
		});
		download_task.start();
	}
	//
	//imgObj[{name: 图片名称,url: 图片url,image: 本地图片路径,index:图片顺序}]
	//
	function checkImage(image_url, local_image_url, index, callback) {
		// 平台绝对路径
		let absolute_image_path = plus.io.convertLocalFileSystemURL(local_image_url);
		// console.log(absolute_image_path);
		// 判断本地是否存在该文件，存在就就直接使用，否则就下载
		plus.io.resolveLocalFileSystemURL(absolute_image_path, function(entry) {
			if (entry) {
				// console.log('已存在');
				var local_image_url_res = plus.io.convertLocalFileSystemURL(local_image_url);
				callback(local_image_url_res, index)
			} else {
				download_img(image_url, local_image_url, index, callback);
			}
		}, function(e) {
			console.log("Resolve file URL failed: ");
			download_img(image_url, local_image_url, index, callback);
		});
	}

	function imgCache(savePath, imgObjs, callback) {
		// 1. 转换网络图片地址为本地缓存图片路径，判断该图片是否存在本地缓存
		// http://...jpg -> md5
		// 缓存目录 _downloads/image/(md5).jpg
		var final_image_urls = [];
		for (var i = 0; i < imgObjs.length; i++) {
			var image_url = imgObjs[i].url;
			var image_name = imgObjs[i].name;
			// let image_md5 = md5(image_url);
			// 缓存本地图片url
			var local_image_url = '_downloads/images/' + savePath + '/' + image_name;
			checkImage(image_url, local_image_url, i, function(res, index) {
				final_image_urls.push({
					index: index,
					url: res
				});
				if (index == imgObjs.length - 1) {
					final_image_urls.sort(compare('index'))
					callback(final_image_urls)
				}
			})
		}
	}

	function compare(property) {
		return function(a, b) {
			var value1 = a[property];
			var value2 = b[property];
			return value1 - value2;
		}
	}
	return {
		imgCacheLaunch: function(imgObjs, callback) {
			imgCache('launch', imgObjs, callback);
		},
		imgCacheIndex: function(imgObjs, callback) {
			imgCache('index', imgObjs, callback);
		}
	};
})();
