var Log = {
	memCode: localStorage.getItem('memcode'),
	getLocalLog: function() {
		var log = localStorage.getItem("log");
		if (log) {
			var arr = this.strArr2ObjArr(log.split("`"));
			if (arr.length > 10) localStorage.setItem("log", ''); //超过10则清空
			return arr;
		} else {
			return [];
		}
	},
	clearLocalLog: function() {
		localStorage.setItem('log', '');
	},
	addLog: function(postData) {
		var logStrArr = [];
		for (var i = 0; i < postData.length; i++) {
			logStrArr.push(JSON.stringify(postData[i]));
		}
		localStorage.setItem("log", logStrArr.join("`"));
	},
	strArr2ObjArr: function(strArr) {
		var newArr = []
		for (var i = 0; i < strArr.length; i++) {
			newArr.push(JSON.parse(strArr[i]));
		}
		return newArr;
	},
	testUpload(errorCode, errorMsg) {
		var _this = this;
		var oldLogArr = _this.getLocalLog();
		var logData = {
			memCode: 'www',
			errorCode: errorCode,
			errorMsg: errorMsg,
			phoneType: 'phoneType',
			sysVersion: mui.os.version,
			appVersion: 'appVersion',
			imei: mui.os.imei || '',
			timeStamp: new Date().getTime()
		};
		var postData = [];
		postData = postData.concat(oldLogArr);
		postData.push(logData);
		// console.log(postData);
		$ajax(API_URL + '/Client/SaveLog', {
			data: postData,
			noSendMcode:true,
			dataType: 'json', //服务器返回json格式数据
			type: 'post', //HTTP请求类型
			timeout: 2000, //超时时间设置为2秒；
			contentType:'application/json',
			success: function(data) {
				if (data.Success) {
					_this.clearLocalLog();
				} else {
					_this.addLog(postData);
				}
			},
			error: function(xhr, type, errorThrown) {
				_this.addLog(postData);
			}
		});
	},
	upload: function(errorCode, errorMsg) {
		var _this = this;
		var oldLogArr = _this.getLocalLog();
		plus.runtime.getProperty(plus.runtime.appid, function(inf) {
			var appVersion = inf.version;
			var phoneType = "";
			if (mui.os.android)
				phoneType = "android";
			else if (mui.os.iphone)
				phoneType = "iphone";
			else if (mui.os.ipad)
				phoneType = "ipad";
			else
				phoneType = "other";

			var logData = {
				memCode: _this.memCode,
				errorCode: errorCode,
				errorMsg: errorMsg,
				phoneType: phoneType,
				sysVersion: mui.os.version,
				appVersion: appVersion,
				runVersion: plus.runtime.version,
				imei: mui.os.imei || '',
				model: plus.device.model,
				vendor: plus.device.vendor,
				timeStamp: new Date().getTime()
			};
			var postData = [];
			postData = postData.concat(oldLogArr);
			postData.push(logData);
			$ajax(API_URL + '/Client/SaveLog', {
				data: postData,
				noSendMcode:true,
				dataType: 'json', //服务器返回json格式数据
				type: 'post', //HTTP请求类型
				timeout: 2000, //超时时间设置为2秒；
				contentType:'application/json',
				success: function(data) {
					if (data.Success) {
						_this.clearLocalLog();
					} else {
						_this.addLog(postData);
					}
				},
				error: function(xhr, type, errorThrown) {
					_this.addLog(postData);
				}
			});
		})

	}
}
window.Log = Log;
