mui.init();
var tabs = {};

function initTabs() {
	var subpages = ['index.html', 'product_category.html', 'my_order.html', 'personal_center.html'];
	var subpage_style = {
		top: '0',
		bottom: '50px'
	};

	var aniShow = {};

	//创建子页面，首个选项卡页面显示，其它均隐藏；
	var self = plus.webview.currentWebview();
	for (var i = 0; i < 4; i++) {
		var temp = {};
		var sub = plus.webview.create(subpages[i], subpages[i], subpage_style);
		if (i > 0) {
			sub.hide();
		} else {
			temp[subpages[i]] = "true";
			mui.extend(aniShow,temp);
		}
		self.append(sub);
	}
	//当前激活选项
	var activeTab = subpages[0];
	//选项卡点击事件
	mui('#bar').on('tap', 'a', function(e) {
		var targetTab = this.getAttribute('href');
		var targetWVW = plus.webview.getWebviewById(targetTab);
		if (targetTab == activeTab) {
			return;
		}
		var Memcode = window.localStorage.getItem("memcode");
		if (Memcode == "" || Memcode == null) {
			mui.openWindow("login.html");
			return;
		}
		switch (targetTab) {
			case "index.html":
				mui.fire(targetWVW, 'refreshData');
				break;
			case "product_category.html":
				mui.fire(targetWVW, 'refreshAmount');
				break;
			case "my_order.html":
				mui.fire(targetWVW, 'refreshOrder');
				break;
			case "personal_center.html":
				mui.fire(targetWVW, 'initMoney');
				break;
		}
		//显示目标选项卡
		//若为iOS平台或非首次显示，则直接显示
		if(mui.os.ios||aniShow[targetTab]){
			plus.webview.show(targetTab);
		}else{
			//否则，使用fade-in动画，且保存变量
			var temp = {};
			temp[targetTab] = "true";
			mui.extend(aniShow,temp);
			plus.webview.show(targetTab,"fade-in",300);
		}
		//隐藏当前;
		plus.webview.hide(activeTab);
		//更改当前活跃的选项卡
		activeTab = targetTab;
	});
	//自定义事件，模拟点击“首页选项卡”
	// document.addEventListener('gohome', function() {
	// 	var defaultTab = document.getElementById("defaultTab");
	// 	//模拟首页点击
	// 	mui.trigger(defaultTab, 'tap');
	// 	//切换选项卡高亮
	// 	var current = document.querySelector(".mui-bar-tab>.mui-tab-item.mui-active");
	// 	if (defaultTab !== current) {
	// 		current.classList.remove('mui-active');
	// 		defaultTab.classList.add('mui-active');
	// 	}
	// });
}

function updateLoginCount(memCode) {
	$ajax(API_URL + "/Member/UpdateLoginCount", {
		data: {
			memCode: memCode
		},
		dataType: 'json', //服务器返回json格式数据
		type: 'post', //HTTP请求类型
		timeout: 10000, //超时时间设置为10秒；
		success: function(data) {

		}
	})
}
//打开App判断密码是否已更改
function checkPwd(memCode, callback) {
	$ajax(API_URL + "/Member/CheckMemPwd", {
		data: {
			memCode: memCode,
			pwd: localStorage.getItem("mempwd")
		},
		dataType: 'json', //服务器返回json格式数据
		type: 'post', //HTTP请求类型
		timeout: 10000, //超时时间设置为10秒；
		success: function(data) {
			callback({
				success: data.Success,
				msg: data.Msg
			});
		},
		error: function() {
			mui.toast('连接失败，请检查你的网络连接！');
		}
	})
}

window.addEventListener('refreshOrder', function(e) {
	mui.fire(tabs['myorder'], 'refreshOrder');
});

mui.plusReady(function() {
	initTabs();
	autoUpdate();
	var memCode = window.localStorage.getItem("memcode");
	checkPwd(memCode, function(res) {
		if (res.success == true) {
			// updateLoginCount(memCode);
		} else {
			mui.alert(res.msg, '提示', '', function(e) {
				window.localStorage.clear();
				mui.openWindow('login.html');
			})
		}
	})

});

window.addEventListener('refreshData', function(e) {
	mui.fire(tabs['personalcenter'], 'refreshData');
});
