var memcode = window.localStorage.getItem("memcode");
var txtStartDate = document.getElementById("starttime");
var txtEndDate = document.getElementById("endtime");

mui.init({
	swipeBack: false //启用右滑关闭功能
});

function initData() {
	if(memcode == "" || memcode == null) {
		mui.openWindow("login.html");
	}
	var date = new Date();
	var startDate = RDateUtil.addDate(date, -7);
	txtStartDate.value = RDateUtil.formatDate(startDate, "yyyy-MM-dd");
	txtEndDate.value = RDateUtil.formatDate(date, "yyyy-MM-dd");
	searchData();
}

function initView() {
	var btns = mui('.ui-alert');
	btns.each(function(i, btn) {
		btn.addEventListener('tap', function() {
			var _self = this;
			if(_self.picker) {
				_self.picker.show(function(rs) {
					if(id == "starttime") {
						txtStartDate.value = rs.text;
					} else {
						txtEndDate.value = rs.text;
					}
					_self.picker.dispose();
					_self.picker = null;
				});
			} else {
				var optionsJson = this.getAttribute('data-options') || '{}';
				var options = JSON.parse(optionsJson);
				var id = this.getAttribute('id');

				_self.picker = new mui.DtPicker(options);
				_self.picker.show(function(rs) {

					if(id == "starttime") {
						txtStartDate.value = rs.text;
					} else {
						txtEndDate.value = rs.text;
					}
					_self.picker.dispose();
					_self.picker = null;
				});
			}

		}, false);
	});

	document.getElementById("btnsearch").addEventListener('tap', function() {
		searchData();
	});
}

function searchData() {
	if(txtStartDate.value == "") {
		mui.alert("请选择开始日期","","",null,"div");
		return false;
	}
	if(txtEndDate.value == "") {
		mui.alert("请选择结束日期","","",null,"div");
		return false;
	}
	$ajax(API_URL + '/Payrecord/GetPayrecordList', {
		data: {
			startTime: txtStartDate.value,
			endTime: txtEndDate.value,
			memCode: memcode
		},
		dataType: 'json', //服务器返回json格式数据
		type: 'get', //HTTP请求类型
		timeout: 10000, //超时时间设置为10秒；
		headers: {
			'Content-Type': 'application/json'
		},
		beforeSend: function() {
			if(IS_APP) {
				plus.nativeUI.showWaiting("加载中，请稍候...");
			}
		},
		complete: function() {
			if(IS_APP) {
				plus.nativeUI.closeWaiting();
			}
		},
		success: function(data) {
			var objs = data.Rows;
			var html = "";
			if(objs.length == 0) {
				html = '<tr><td>没有找到相关信息！<td></tr>';
			} else {
				html += '<tr>';
				html += '<th style="width:25%;">日期</th>';
				html += '<th style="width:25%;">交易类型</th>';
				html += '<th>收支</th>';
				html += '<th>余额</th>';
				html += '</tr>';
				for(var j = 0; j < objs.length; j++) {
					html += '<tr>';
					html += '<td>' + objs[j].Paydate + '</td>';
					html += '<td>' + objs[j].Remark + '</td>';
					html += '<td>' + objs[j].Payin + '</td>';
					html += '<td>' + objs[j].Enableaccount + '</td>';
					html += '</tr>';
				}
			}
			document.getElementById("tablemoney").innerHTML = html;
		}
	});
}

if(IS_APP) {
	mui.plusReady(function() {
		initView();
		initData();
	});
} else {
	initView();
	initData();
}