// var memcode = '79206';
// var orderNum = 'D-79206220418-ALL';
// var sSite = '缤纷总网';
// var saleDate = '2022-04-18';
// var orderType = 'onsale';

var memcode = window.localStorage.getItem("memcode");
var orderNum = '';
var sSite = '';
var saleDate = '';
var orderType = '';

var pageIndex = 1;
var pageSize = 20;
var pageCount = 0;

function initScroll() {
	mui.init({
		swipeBack: false, //启用右滑关闭功能
		pullRefresh: {
			container: ".mui-scroll-wrapper", //待刷新区域标识，querySelector能定位的css选择器均可，比如：id、.class等
			up: {
				height: 50, //可选.默认50.触发上拉加载拖动距离
				auto: true, //可选,默认false.自动上拉加载一次
				contentrefresh: "正在加载...", //可选，正在加载状态时，上拉加载控件上显示的标题内容
				contentnomore: '没有更多数据了', //可选，请求完毕若没有更多数据时显示的提醒内容；
				callback: function(){
					setTimeout(initData,100)
				} //必选，刷新函数，根据具体业务来编写，比如通过ajax从服务器获取新数据；
			}
		}
	});
}


var productDetailKey = [{
		value: "Slength",
		text: "长度"
	},
	{
		value: "Blade",
		text: "叶片"
	},
	{
		value: "Bud",
		text: "花苞"
	},
	{
		value: "Stalk",
		text: "茎杆"
	},
	{
		value: "Bending",
		text: "枝条弯曲度"
	},
	{
		value: "Diseased",
		text: "病虫害"
	},
	{
		value: "Openness",
		text: "开放度"
	},
	{
		value: "Damage",
		text: "机械损伤"
	}
]
if (orderType == "onsale") {
	document.getElementById("orderType").innerHTML = "现售";
} else {
	document.getElementById("orderType").innerHTML = "预定";
}

function setStarsStatus(rate) {
	rate = parseInt(rate);
	var html = '';
	for (var x = 0; x < rate; x++) {
		html += '<span data-index="' + (x + 1) + '" class="sel">★</span>';
	}
	if (rate < 5) {
		var end = 5;
		for (var y = end; y > rate; y--) {
			html += '<span data-index="' + y + '" >★</span>';
		}
	}
	return html;
}

function isMore(total) {
	pageCount = Math.ceil(total /pageSize);
	if (pageIndex * pageSize >= total) {
		console.log('no more');
		mui('.mui-scroll-wrapper').pullRefresh().endPullupToRefresh(true);
	} else {
		// pageIndex++;
		mui('.mui-scroll-wrapper').pullRefresh().endPullupToRefresh(false);
	}
}

function resetPullUp() {
	mui('.mui-scroll-wrapper').pullRefresh().refresh(true);
	pageIndex = 1;
	document.getElementById("ulOrder").innerHTML = "";
	mui('.mui-scroll-wrapper').scroll().scrollTo(0, 0, 0); //100毫秒滚动到顶
}

function initData() {
	if(pageCount > 0){
		pageIndex++;
		if (pageIndex > pageCount) {
			mui('.mui-scroll-wrapper').pullRefresh().endPullupToRefresh(true);
			return;
		}
	}

	var URL = "/Ordercommit/GetOrderEvaluateAndPdList";
	var reqData = {
		Ordernum: orderNum,
		Orderuser: memcode,
		Ssite: sSite,
		page: pageIndex,
		pageSize: pageSize
	};
	if (orderType == "book") {
		URL = "/Orderbookhis/GetBookDetailByUserCode";
		reqData = {
			saleDate: saleDate,
			memCode: memcode,
			sSite: sSite,
			page: pageIndex,
			pageSize: pageSize
		}
	}
	$ajax(API_URL + URL, {
		data: reqData,
		dataType: 'json', //服务器返回json格式数据
		type: 'get', //HTTP请求类型
		timeout: 10000, //超时时间设置为10秒；
		headers: {
			'Content-Type': 'application/json'
		},
		beforeSend: function() {
			if (IS_APP) {
				plus.nativeUI.showWaiting("加载中...");
			}
		},
		complete: function() {
			if (IS_APP) {
				plus.nativeUI.closeWaiting();
			}
		},
		success: function(data) {
			if (data.Openlogistics) {
				document.getElementById("view_logistics").style.display = "";
			}
			isMore(data.Total);
			if (data.Total <= 0) {
				document.getElementById("ulOrder").innerHTML =
					'<li class="mui-table-view-cell">没有找到相关信息！</li>';
			} else {
				if (orderType == "onsale") {
					showOrderDetail(data);
				} else {
					showOrderBookDetail(data);
				}
			}

			mui("#ulOrder").on('tap', '.view_product', function() {
				var pCode = this.dataset.code;
				getProductByCode(pCode);
			})
		}
	});
}

function showOrderDetail(data) {
	var objs = data.Rows;
	var totalRow = data.TotalRow;
	var allCount = totalRow.Ordercount;
	var allBackCount = totalRow.Backcount;
	var allMoney = totalRow.Ordermoney;
	var allBackMoney = totalRow.Backmoney;
	var html = '';
	for (var i = 0; i < objs.length; i++) {
		var order = objs[i];
		html += '<li class="mui-table-view-cell mui-collapse"><a class="mui-navigate-right" href="#">' +
			'<div class="tra_title"><div class="tra_title_l"><i>' + order.Brand + '</i><span class="t_ul_span">' + order
			.Name +
			'</span></div><div class="tra_title_c"><span>订购:' + order.Ordercount +
			'</span>,<span>缺货:' + order.Backcount +
			'</span>,<span>金额:￥' + (order.Ordermoney * 10 - order.Backmoney * 10) / 10 +
			'</span></div></div></a>' +
			'<div class="mui-collapse-content tra_box"><p>订购时间：' + order.Ordertime + '</p>' +
			'<span class="tra_l">编码：' + order.Code + '</span><span class="tra_r">' + order.Name + '<a>' + order.Grade +
			'</a> ' + order.Color + '</span><br />' +
			'<span class="tra_l">大类：' + order.Lclass + '</span><span class="tra_r">小类：' + order.Sclass +
			'</span><br />' +
			'<span class="tra_l">单价：￥' + order.Orderprice + '</span><span class="tra_r">订购数：' + order.Ordercount +
			'</span><br />' +
			'<span class="tra_l">缺货数：' + order.Backcount + '</span><span class="tra_r">有效数：' + (order.Ordercount - order
				.Backcount) +
			'</span><br />' +
			'<span class="tra_l">订购额：￥' + order.Ordermoney + '</span><span class="tra_r">缺货额：￥' + order.Backmoney +
			'</span><br />' +
			'<span class="tra_l">有效额：<label class="txt-price">' + (order.Ordermoney - order.Backmoney) +
			'</label></span><span class="tra_r"></span>' +
			'<div class="tra-pro"><a href="javascript:;" class="view_product" data-code=' + order.Code +
			'>查看产品</a></div>';
		if (order.Isevaluate == true) {
			var evaData = objs[i];
			var evaImgArr = isNullOrEmpty(evaData.Evaluateimg) ? [] : evaData.Evaluateimg.split(',');
			var evaImgHtml = '';
			var evaImgPreview = [];
			for (var j = 0; j < evaImgArr.length; j++) {
				evaImgPreview.push(QINIU_PREFIX + evaImgArr[j]);
				evaImgHtml += '<img data-index="' + j + '" src="' + QINIU_PREFIX + evaImgArr[j] +
					'?imageView2/1/w/100" class="eva_img-item" >';
			}
			var tmpHtml = '<div class="evaluate" class="evaluate_area"><div class="evaluate_head mui-text-center">' +
				'<a href="javascript:;" class="mui-btn mui-btn-red mui-btn-outlined">已评价</a></div>' +
				'<div class="evaluate_content"><div class="eva_item"><label>星级：</label>' +
				'<span class="stars">' + setStarsStatus(evaData.Evaluaterate) + '</span></div>' +
				'<div class="eva_item"><label>评价：</label><span class="eva_content">' + evaData.Evaluatecontent +
				'</span></div>' +
				'<div class="eva_item" class="eva_imgs">' + evaImgHtml + '</div><p class="eva_time">' + evaData
				.Evaluatetime +
				'</p>' +
				'</div></div>';
			html += tmpHtml;
		} else {
			html +=
				'<div class="mui-text-center tra-btn"><a id="goEvaluate" href="javascript:;" _href="order_evaluate.html" data-id="' +
				order.Id + '" class="mui-btn opWindow">去评价</a></div>';
		}
		html += '</div></li>';
	}
	var sumHtml = '<div class="order_sum my_sum">合计：有效数：' + (allCount - allBackCount) +
		'，有效额：<label class="txt-price">' +
		(allMoney - allBackMoney) + '<label></div>';

	document.getElementById("spanSum").innerHTML = sumHtml;
	document.getElementById("spanTotal").innerHTML = data.Total;
	document.getElementById("ulOrder").innerHTML += html;
	mui("#ulOrder").on('tap', '.eva_img-item', function() {
		var index = this.dataset.index;
		plus.nativeUI.previewImage(evaImgPreview, {
			current: index
		});
	})
}

function showOrderBookDetail(data) {
	var objs = data.Rows;
	var totalRow = data.TotalRow;
	var allCount = totalRow.Ordercount;
	var allMoney = totalRow.Ordermoney;
	var html = '';
	for (var i = 0; i < objs.length; i++) {
		var order = objs[i];
		allCount += order.Ordercount;
		allMoney += order.Ordermoney * 10;
		html += '<li class="mui-table-view-cell mui-collapse"><a class="mui-navigate-right" href="#">' +
			'<div class="tra_title"><div class="tra_title_l"><i>' + order.Brand + '</i><span class="t_ul_span">' + order
			.Name +
			'</span></div><div class="tra_title_c"><span>订购:' + order.Ordercount +
			'</span>,<span>金额:￥' + order.Ordermoney +
			'</span></div></div></a>' +
			'<div class="mui-collapse-content tra_box"><p>订购时间：' + order.Ordertime + '</p>' +
			'<span class="tra_l">编码：' + order.Code + '</span><span class="tra_r">' + order.Name + '<a>' + order.Grade +
			'</a> ' + order.Color + '</span><br />' +
			'<span class="tra_l">大类：' + order.Lclass + '</span><span class="tra_r">小类：' + order.Sclass +
			'</span><br />' +
			'<span class="tra_l">单价：￥' + order.Orderprice + '</span><span class="tra_r">订购数：' + order.Ordercount +
			'</span><br />' +
			'<span class="tra_l">订购额：￥' + order.Ordermoney + '</span><span class="tra_r">' +
			'</span>' +
			'<div class="tra-pro"><a href="javascript:;" class="view_product" data-code=' + order.Code +
			'>查看产品</a></div>' +
			'</div></li>';
	}
	var sumHtml = '<div class="order_sum my_sum">合计：订购数：' + allCount + '，金额：<label class="txt-price">' +
		allMoney + '<label></div>';

	document.getElementById("spanSum").innerHTML = sumHtml;
	document.getElementById("spanTotal").innerHTML = data.Total;
	document.getElementById("ulOrder").innerHTML += html;
}

//显示产品详细信息
function showProInfo(product) {
	var html = '';
	for (var i = 0; i < productDetailKey.length; i++) {
		var v = productDetailKey[i].value;
		var t = productDetailKey[i].text;
		var proValue = product[v];
		if (proValue != "" && proValue != null) {
			html += '<li class="mui-table-view-cell">' + t + '：' + proValue + '</li>';
		}
	}
	document.getElementById("main_info").innerHTML = html;
	mui('#popover').popover("show");
}

function getProductByCode(productCode) {
	$ajax(API_URL + '/Product/GetProductList', {
		data: {
			Code: productCode
		},
		dataType: 'json', //服务器返回json格式数据
		type: 'get', //HTTP请求类型
		timeout: 10000, //超时时间设置为10秒；
		beforeSend: function() {
			if (IS_APP) {
				plus.nativeUI.showWaiting('加载中...');
			}
		},
		complete: function() {
			if (IS_APP) {
				plus.nativeUI.closeWaiting();
			}
		},
		success: function(data) {
			if (data.Total > 0) {
				var obj = data.Rows[0];
				showProInfo(obj);
			} else {
				alert('产品不存在！');
			}
		},
		error: function(xhr, type, errorThrown) {

		}
	});
}

function initView() {
	//订单号
	document.getElementById("sSite").innerHTML = "[" + sSite + "]";
	document.getElementById("orderNum").innerHTML = orderNum;

	mui(document.body).on('tap', '.opWindow', function() {
		mui.openWindow(this.getAttribute('_href') + '?id=' + this.dataset.id);
	})
	document.getElementById('view_logistics').addEventListener('tap', function() {
		mui.openWindow('view_logistics.html?ordernum=' + orderNum);
	})
}

if (IS_APP) {
	mui.plusReady(function() {
		var self = plus.webview.currentWebview();
		orderNum = self.code;
		sSite = self.ssite;
		saleDate = self.saledate;
		orderType = self.ordertype;
		
		// initData();
		initScroll();
		initView();
	});
} else {
	// initData();
	initScroll();
	initView();
}

window.addEventListener('refreshData', function() {
	initData();
})
