mui.init();

var greenPageIndex = 1;
var yellowPageIndex = 1;
var favorIndex = 1;
var newPageIndex = 1;
var productTypeList = new Array(); //大类列表
var productClassList = null; //所有分类列表
var smallType = []; //小类
var bigType = []; //大类
var isForSale = true; //是否在售
var isFlag = window.localStorage.getItem('isFlag');
var saleDate = RDateUtil.formatDate((new Date()), "yyyy-MM-dd");
var currentProduct = null;
var productList = [];
var memCode = window.localStorage.getItem('memcode');
var orderName = window.localStorage.getItem('memName');
var deposit = null;
var market = localStorage.getItem('market') ? localStorage.getItem('market') : '缤纷总网';; //站点 
var color = ''; //颜色
var brand = ''; //品牌
var grade = ''; //等级
var searchType = 0; //0-全部；1-有底价；2-无底价；3-不竞购
var divType = document.getElementById("divType");
var divFavor = document.getElementById("divFavor");
var divSale = document.getElementById("divSale");
var divBook = document.getElementById("divBook");
var isMultiSearch = false; //是否多选

(function($) {
	//阻尼系数
	var deceleration = mui.os.ios ? 0.003 : 0.0009;
	mui('.mui-slider').slider().stopped = true; //禁止左右滑动

	$('.mui-scroll-wrapper').scroll({
		bounce: false,
		indicators: true, //是否显示滚动条
		deceleration: deceleration
	});
	var lazyLoad = mui('#ulgreenlist').imageLazyload({
		placeholder: './images/60x60.gif',
		autoDestroy: false
	});
	$.ready(function() {
		//循环初始化所有下拉刷新，上拉加载。
		var createFragment = function(ul, index, reverse) {
			if (index == 0) {
				isForSale = true;
				loadPageData(smallType, bigType, index, ul);
			} else if (index == 1) {
				isForSale = false;
				//若是第一页，则提醒要选择日期
				if (yellowPageIndex == 1) {
					doBook();
				} else {
					loadPageData(smallType, bigType, index, ul);
				}

			}
		};
		$.each(document.querySelectorAll('.mui-slider-group .mui-scroll2'), function(index, pullRefreshEl) {
			$(pullRefreshEl).pullToRefresh({
				up: {
					auto: false,
					callback: function() {
						var self = this;
						var ul = self.element.querySelector('.mui-table-view');
						setTimeout(function() {
							createFragment(ul, index, false);
							self.endPullUpToRefresh();
						}, 200)
					}
				},
				down: {
					style: 'circle', //必选，下拉刷新样式，目前支持原生5+ ‘circle’ 样式
					container: ".mui-table-view",
					auto: false,
					callback: function() {
						var self = this;
						productList = [];
						setTimeout(function() {
							if (!isForSale) {
								doBook();
							} else {
								search();
							}
							self.endPullDownToRefresh();
						}, 200)
					}
				}
			});
		});
		//MyLove
		$('.mui-slider-group .mui-scroll3').pullToRefresh({
			up: {
				callback: function() {
					var self = this;
					var ul = self.element.querySelector('.mui-table-view');
					setTimeout(function() {
						initFavor();
						self.endPullUpToRefresh();
					}, 200);
				}
			},
			down: {
				style: 'circle', //必选，下拉刷新样式，目前支持原生5+ ‘circle’ 样式
				container: ".mui-table-view",
				callback: function() {
					var self = this;
					favorIndex = 1;
					setTimeout(function() {
						initFavor();
						self.endPullDownToRefresh();
					}, 200);
				}
			}
		});

	});
})(mui);

/*
 * 根据Id获取产品对象
 */
function getProductById(id) {
	for (var i = 0; i < productList.length; i++) {
		if (productList[i].Id == id) {
			return productList[i];
		}
	}
	return null;
}

//订购
function doOrder(id) {
	console.log(productList)
	var canDoOrder = initServerInfo(memCode, market);
	if (!canDoOrder) {
		return;
	}
	currentProduct = getProductById(id);
	if (currentProduct.Timelycount == 0) {
		mui.alert("抱歉，该产品已卖光了", "");
		return;
	}
	var bookordercount = document.getElementById("bc" + id).value;
	if (bookordercount < 1) {
		mui.alert("订购数需大于0", "");
		return;
	} else if (bookordercount > currentProduct.Timelycount) {
		mui.alert("订购数不能大于库存数", "");
		return;
	}
	var myDate = new Date();
	var curdatetime = myDate.toLocaleString();
	mui.post(API_URL + '/Orderdg/DoOrder', {
		vSaleMan: memCode,
		vOrderUser: memCode,
		vOrderName: orderName,
		vSaleDate: currentProduct.Saledate,
		vCode: currentProduct.Code,
		vDeposit: deposit, //手续费百分比
		vOrderType: 19,
		visVir: currentProduct.Isvir,
		vOrderPrice: currentProduct.Price,
		vsSite: currentProduct.Ssite,
		vOrderCount: bookordercount,
		time: new Date().getMilliseconds()
	}, function(data) {
		var ErrorCode = parseInt(data.ErrorCode);
		if (ErrorCode == 1) {
			currentProduct.Timelycount = currentProduct.Timelycount - bookordercount;
			document.getElementById("eid" + currentProduct.Id).innerHTML = currentProduct.Timelycount;
			initUserInfo();
			mui.alert("订购成功！", "");
		} else if (ErrorCode == 12) {
			mui.alert("余额不足，请充值后再购买。", "");
		} else {
			mui.alert(data.Msg, "");
		}
	}, 'json');
}

//竞购
function bidOrder(id) {
	var canDoOrder = initServerInfo(memCode, market);
	if (!canDoOrder) {
		return;
	}
	var priceReg = /((^[1-9]\d*)|^0)(\.\d{0,1}){0,1}$/;
	currentProduct = getProductById(id);
	if (currentProduct.Timelycount == 0) {
		mui.alert("抱歉，该产品已卖光了", "");
		return;
	}
	var contestorderprice = document.getElementById("price" + id).value;
	if (!priceReg.test(contestorderprice)) {
		mui.alert("请输入正确的价格格式", "提示");
		return false;
	}
	var contestordercount = document.getElementById("bc2" + id).value;
	if (contestordercount < 1) {
		mui.alert("竞购数需大于0", "");
		return;
	}
	var Wholesaleprice = document.getElementById("price" + id).dataset.floor; //底价
	if (parseFloat(contestorderprice) < parseFloat(Wholesaleprice)) {
		mui.alert("竞购价格不能低于底价", "提示");
		return false;
	} else if (parseFloat(contestorderprice) >= parseFloat(currentProduct.Price)) {
		mui.alert("竞购价格不能高于或等于正价", "提示");
		return false;
	} else if (contestordercount > currentProduct.Timelycount) {
		mui.alert("订购数不能大于库存数", "");
		return;
	}
	var myDate = new Date();
	var curdatetime = myDate.toLocaleString();
	mui.post(API_URL + '/Orderdg/DoBidOrder', {
		vSaleMan: memCode,
		vOrderUser: memCode,
		vOrderName: orderName,
		vSaleDate: currentProduct.Saledate,
		vCode: currentProduct.Code,
		vDeposit: deposit, //手续费百分比
		visVir: currentProduct.Isvir,
		vOrderPrice: contestorderprice,
		vsSite: currentProduct.Ssite,
		vOrderCount: contestordercount,
		time: new Date().getMilliseconds()
	}, function(data) {
		var ErrorCode = parseInt(data.ErrorCode);
		if (ErrorCode == 1) {
			initUserInfo();
			mui.alert("竞购成功！", "");
		} else if (ErrorCode == 12) {
			mui.alert("余额不足，请充值后再购买。", "");
		} else {
			mui.alert(data.Msg, "");
		}
	}, 'json');
}

//预订
function bookOrder(id) {
	currentProduct = getProductById(id);
	var bookordercount = document.getElementById("bb" + id).value;
	if (bookordercount < 1) {
		mui.alert("预订数需大于0", "");
		return;
	} else if (bookordercount > currentProduct.Maxcount) {
		mui.alert("预订数不能大于可订最高数", "");
		return;
	} else if (bookordercount < currentProduct.Mincount) {
		mui.alert("预订数不能小于可订最低数", "");
		return;
	}

	mui.post(API_URL + '/Orderdg/DoBookOrder', {
		vSalesMan: memCode,
		vOrderUser: memCode,
		vOrderName: orderName,
		vSaleDate: saleDate,
		vCode: currentProduct.Code,
		vDeposit: deposit, //手续费百分比
		vOrderPrice: currentProduct.Averprice,
		vOrderCount: bookordercount,
		vsSite: market,
		time: new Date().getMilliseconds()
	}, function(data) {
		var ErrorCode = parseInt(data.ErrorCode);
		if (ErrorCode == 1) {
			initUserInfo();
			mui.alert("预订成功！", "");
		} else if (ErrorCode == 12) {
			mui.alert("余额不足，请充值后再购买。", "");
		} else {
			mui.alert(data.Msg, "");
		}
	}, 'json');
}

function setFavour(productCode) {
	$ajax(API_URL + '/Mylove/AddOrUpdateFromH5', {
		data: {
			Orderuser: memCode,
			Code: productCode
		},
		dataType: 'json', //服务器返回json格式数据
		type: 'POST', //HTTP请求类型
		timeout: 10000, //超时时间设置为10秒；
		success: function(data) {
			var loveId = parseInt(data.RecordId);
			if (loveId > 0) {
				mui.toast(data.Msg);
				//更新我的最爱
				// initFavor();
			} else {
				mui.toast(data.Msg);
			}
		}
	});
}

/*
idx:0-在售；1-预订 
*/
var imgIndex = 0;

function loadPageData(smallType, bigType, idx, ul) {
	var url = "/Product/GetListByCode";
	if (idx == 0) {
		newPageIndex = greenPageIndex;
	} else {
		newPageIndex = yellowPageIndex;
		url = "/Product/GetBookListByCode";
	}
	// console.log(smallType)

	$ajax(API_URL + url, {
		data: {
			ptype: bigType.join(','),
			pclass: smallType.join(','),
			page: newPageIndex,
			pageSize: 10,
			site: market,
			color: color,
			brand: brand,
			grade: grade,
			searchType: searchType,
			saleDate: saleDate
		},
		dataType: 'json', //服务器返回json格式数据
		type: 'post', //HTTP请求类型
		timeout: 10000, //超时时间设置为10秒；
		// beforeSend: function() {
		// 	if (IS_APP) {
		// 		plus.nativeUI.showWaiting();
		// 	}
		// },
		// complete: function() {
		// 	if (IS_APP) {
		// 		setTimeout(function() {
		// 			plus.nativeUI.closeWaiting();
		// 		}, 200);
		// 	}
		// },
		success: function(data) {
			// mui.toast('页数：' + newPageIndex)
			//若是初始加载，则清空UL内容
			// console.log(data.Total)
			if (newPageIndex == 1) {
				ul.innerHTML = "";
			}
			var objs = data.Rows;
			if (objs != null && objs.length > 0) {
				var li;
				for (var i = 0; i < objs.length; i++) {
					imgIndex++;
					productList.push(objs[i]);
					li = document.createElement('li');
					li.className = 'mui-table-view-cell mui-media seach_li mui-collapse';
					var html = '<a class="mui-navigate-right">';
					html += '<div class="od_allbox">';
					html +=
						'<div class="od_left od_left0"><img onerror="this.src=\'./images/white_bg.png\';this.onerror=null" data-preview-group="' +
						imgIndex +
						'" data-preview-src="http://img.brightenflower.cn/' + objs[i].Picpath +
						'" class="seach_img" src="http://img.brightenflower.cn/' +
						objs[i].Picpath + '?imageView2/0/w/120/h/200"></div>';
					html += '<div class="mui-media-body seach_title od_right" pid="' + objs[i].Id + '">';
					html += '<div class="od_title od_dj">' + objs[i].Brand + '&nbsp;&nbsp;' + objs[i].Name + '</div>';
					html += '<div class="od_dj"><span>编码：<i>' + objs[i].Code + '</i></span><span>等级：<i>' + objs[i].Grade +
						'</i></span></div>';
					html += '<div class="od_dj">';
					html += '<span>颜色：<i>' + objs[i].Color + '</i></span><span>长度：<i>' + objs[i].Slength + '</i></span>';
					if (idx == 0) {
						html += '</div><div class="od_dj"><span>包装：<i>' + objs[i].Packcount + '</i></span><span>可售：<i id="eid' + objs[
							i].Id + '">' + objs[i].Timelycount + '</i>' + objs[i].Unit + '</span>';
						html += '</div>';
						html += '<div class="od_dj od_littlefont">';
						html += '<span>单价：<i>' + objs[i].Price + '元/' + objs[i].Unit + '</i></span>';
						html += '<span><button loadUrl="product_details.html?id=' + objs[i].Id +
							'" type="button" class="mui-btn mui-btn-warning btn-detail" />详情</button>';
						html += '<button type="button" fid="' + objs[i].Code +
							'" class="mui-btn mui-icon-extra mui-icon-extra-heart-filled btn-favor" /></button</span>';
						html += '</div></div></div></a>';
						html +=
							'<div class="mui-collapse-content"><div class="mui-card"><div class="de_nowbuy"><div class="de_nowbuy_title">订购</div><div class="de_nowbuybox"><div class="de_xg"><span>数量：</span>';
						html +=
							'<div class="mui-numbox de_border" data-numbox-min="1"><button class="mui-btn mui-btn-numbox-minus" type="button">-</button>';
						html += '<input id="bc' + objs[i].Id +
							'" class="mui-input-numbox" type="number"/><button class="mui-btn mui-btn-numbox-plus" type="button">+</button>';
						html += '</div><button class="de_buybtn" name="btnDoOrder" onclick="doOrder(' + objs[i].Id +
							')">订购</button></div><div style="clear: both;"></div></div></div>';
						if (objs[i].Isbid == 1) {
							html +=
								'<div class="mui-collapse-content"><div class="de_nowbuy"><div class="de_nowbuy_title jg">竞购</div><div class="de_nowbuybox"><div class="de_xg"><span>价格：</span><input id="price' +
								objs[i].Id +
								'" class="mui-input-clear" type="text" data-input-clear="5" oninput="limitPrice(this)" data-floor="' + objs[
									i].Floorprice + '" /><span class="dj">底价：<i>' + objs[i]
								.Floorprice + '元/' + objs[i].Unit + '</i><span></div>';
							html +=
								'<div class="de_xg"><span>数量：</span><div class="mui-numbox de_border" data-numbox-min="1"><button class="mui-btn mui-btn-numbox-minus" type="button">-</button>';
							html += '<input id="bc2' + objs[i].Id +
								'" class="mui-input-numbox" type="number" /><button class="mui-btn mui-btn-numbox-plus" type="button">+</button>';
							html += '</div><button class="de_buybtn jg" name="btnBidOrder" onclick="bidOrder(' + objs[i].Id +
								')">竞购</button></div></div></div></div></div>';
						}
					} else {
						html += '</div><div class="od_dj"><span>包装：<i>' + objs[i].Packcount + '</i></span><span>参考：<i>' + objs[i].Averprice +
							'元/' + objs[i].Unit + '</i>' + '</span>';
						html += '</div>';
						html += '<div class="od_dj od_littlefont">';
						html += '<span>最高：<i>' + objs[i].Maxcount + objs[i].Unit + '</i></span><span>最低：<i>' + objs[i].Mincount + objs[
							i].Unit + '</i></span>';
						html += '<span><button loadUrl="product_details.html?id=' + objs[i].Id +
							'" type="button" class="mui-btn mui-btn-warning btn-detail" />详情</button>';
						html += '<button type="button" fid="' + objs[i].Code +
							'" class="mui-btn mui-icon-extra mui-icon-extra-heart-filled btn-favor" /></button</span>';
						html += '</div></div></div></a>';
						html +=
							'<div class="mui-collapse-content"><div class="mui-card"><div class="de_nowbuy"><div class="de_nowbuy_title">预订</div><div class="de_nowbuybox"><div class="de_xg"><span>数量：</span>';
						html +=
							'<div class="mui-numbox de_border" data-numbox-min="' + objs[i].Mincount +
							'"><button class="mui-btn mui-btn-numbox-minus" type="button">-</button>';
						html += '<input id="bb' + objs[i].Id +
							'" class="mui-input-numbox" type="number" /><button class="mui-btn mui-btn-numbox-plus" type="button">+</button>';
						html += '</div><button class="de_buybtn" name="btnBookOrder" onclick="bookOrder(' + objs[i].Id +
							')">预定</button></div><div style="clear: both;"></div></div></div>';
						html += '</div></div>';
					}
					li.innerHTML = html;
					ul.appendChild(li);
				}

				mui('#ulgreenlist .od_right,#ulyellowlist .od_right').off('tap', '.btn-detail');
				mui('#ulgreenlist .od_right,#ulyellowlist .od_right').on('tap', '.btn-detail', function() {
					mui.openWindow(this.getAttribute("loadUrl") + "&isForSale=" + (idx == 0 ? "1" : "0") + "&saleDate=" +
						saleDate);
					return false;
				});
				mui('.od_littlefont').on('tap', '.btn-favor', function() {
					var productCode = this.getAttribute("fid");
					setFavour(productCode);
					return false;
				});
				//重新加载numbox控件
				mui(".mui-numbox").numbox();
				mui.previewImage();
				if (idx == 0) {
					greenPageIndex++;
				} else {
					if (yellowPageIndex == 1) {
						mui('#scroll2').scroll().scrollTo(0, 0, 100); //重新初始化
					}
					yellowPageIndex++;
				}
			} else {
				if (newPageIndex == 1) {
					ul.innerHTML = "<li class='mui-table-view-cell mui-media seach_li'>暂无产品哦，或者你可以换个条件再查查？</li>";
					// mui('#scroll1').scroll().scrollTo(0, 1000, 10);
				}
			}
			// mui('#scroll1').scroll().scrollTo(0, 1000, 10);
		}
	});
}

//显示小类
function showSubTypeList(parentName) {
	var subHtml = "";
	var typecount = 0;
	var idx = 0;
	for (var i = 0; i < productClassList.length; i++) {
		if (productClassList[i].Lclass == parentName) {
			idx++;
			if (typecount == 0) {
				subHtml += '<li class="bigcateli' + (existItem(bigType, parentName) ? " active" : "") + '" ptype="' + parentName +
					'">全部' + parentName + '</li>';
				subHtml += '<li class="' + (idx % 2 == 1 ? "marginright4 " : "") + 'samllcateli' + (existItem(smallType, parentName +
						"_" + productClassList[i].Sclass) ? " active" : "") +
					'" ptype="' + parentName + '" pclass="' + productClassList[i].Sclass + '">' + productClassList[i].Sclass + '</li>';
			} else {
				subHtml += '<li class="' + (idx % 2 == 1 ? "marginright4 " : "") + 'samllcateli' + (existItem(smallType, parentName +
						"_" + productClassList[i].Sclass) ? " active" : "") +
					'" ptype="' + parentName + '" pclass="' + productClassList[i].Sclass + '">' + productClassList[i].Sclass + '</li>';
			}
			typecount++;
		}
	}
	document.getElementById("smallUlTypeList").innerHTML = subHtml;
}

//获取分类
function initType() {
	//获取分类
	$ajax(API_URL + '/Productclassa/GetProductclassaList', {
		data: {
			pageSize: 1000
		},
		dataType: 'json', //服务器返回json格式数据
		type: 'post', //HTTP请求类型
		timeout: 100000, //超时时间设置为10秒；
		success: function(data) {
			productClassList = data.Rows;
			for (var i = 0; i < productClassList.length; i++) {
				var curType = productClassList[i].Lclass;
				if (productTypeList.indexOf(curType) == -1) {
					productTypeList.push(curType);
				}
			}
			var html = "";
			for (var x = 0; x < productTypeList.length; x++) {
				if (x == 0) {
					html += '<li class="colorgreen show_sub_type">' + productTypeList[x] + '</li>';
				} else {
					html += '<li class="show_sub_type">' + productTypeList[x] + '</li>';
				}
			}
			document.getElementById("divTypelist").innerHTML = html;
			showSubTypeList(productTypeList[0]); //初始小类
			//点击大类显示小类
			mui('#divTypelist').on('tap', '.show_sub_type', function(e) {
				var lastActiveElem = document.querySelector('#divTypelist li.colorgreen');
				lastActiveElem && lastActiveElem.classList.remove('colorgreen');
				this.classList.add("colorgreen");
				showSubTypeList(this.innerHTML);
			});
		}
	});
}
//获取站点
function initSite() {
	$ajax(API_URL + '/Product/GetSaleSite', {
		data: {},
		dataType: 'json', //服务器返回json格式数据
		type: 'get', //HTTP请求类型
		timeout: 10000, //超时时间设置为10秒；
		success: function(data) {
			var objs = data.Rows;
			if (objs.length > 0) {
				var html = '<li class="mui-table-view-cell ">' +
					'<a onclick="javascript:mui.openWindow(\'my_order.html?isBack=1\');" class="mui-navigate-right">我的订单</a>' +
					'</li>';
				for (var i = 0; i < objs.length; i++) {
					html += '<li class="mui-table-view-cell"><a class="mui-navigate-right" onclick="chooseSite(\'' + objs[i].Ssite +
						'\',' + objs[i].IsFlag + ')">' + objs[i].Ssite + '</a></li>';
					if (objs[i].Ssite == market) {
						isFlag = objs[i].IsFlag; //重新加载设置isflag
						localStorage.setItem('isFlag', isFlag);
					}
				}
				document.getElementById("middlePopover").style.height = ((objs.length + 1) * 46) + "px";
				document.getElementById("ulSite").innerHTML = html;
			}
		}
	});
}

//取消收藏
function cancelFavor(loveId) {
	var memCode = window.localStorage.getItem('memcode');
	if (memCode) {
		$ajax(API_URL + '/Mylove/AddOrUpdateFromH5', {
			data: {
				Memcode: memCode,
				Id: loveId
			},
			dataType: 'json', //服务器返回json格式数据
			type: 'POST', //HTTP请求类型
			timeout: 10000, //超时时间设置为10秒；
			success: function(data) {
				mui.toast('取消成功!');
				initFavor(true);
			}
		});
	}
}

function initFavor(isOtherSite) {
	//获取我的最爱
	var memCode = window.localStorage.getItem('memcode');
	if (memCode) {
		if (isOtherSite) {
			favorIndex = 1;
		}
		newPageIndex = favorIndex;
		// document.getElementById("mylovelist").innerHTML = '';
		var url = API_URL + '/Mylove/GetListByMemcode';
		if (!isForSale) {
			url = API_URL + '/Mylove/GetBookListByMemcode';
		}
		$ajax(url, {
			data: {
				memCode: memCode,
				saleDate: saleDate,
				site: market,
				isFlag: isFlag,
				pageIndex: newPageIndex,
				pageSize: 20
			},
			dataType: 'json', //服务器返回json格式数据
			type: 'post', //HTTP请求类型
			timeout: 100000, //超时时间设置为10秒；
			success: function(data) {
				var objs = data.Rows;
				if (objs != null && objs.length > 0) {
					var html = "";
					for (var i = 0; i < objs.length; i++) {
						productList.push(objs[i]);
						html += '<li class="mui-table-view-cell mui-media seach_li mui-collapse">';
						html += '<a class="mui-navigate-right">';
						html += '<div class="od_allbox">';
						html += '<div class="od_left"><img data-preview-group="' + i +
							'" data-preview-src="http://img.brightenflower.cn/' + objs[i].Picpath +
							'" class="mui-media-object mui-pull-left seach_img" src="http://img.brightenflower.cn/' + objs[i].Picpath +
							'?imageView2/0/w/120/h/200"></div>';
						html += '<div class="mui-media-body seach_title od_right" pid="' + objs[i].Id + '">';
						html += '<div class="od_title">' + objs[i].Brand + '&nbsp;' + objs[i].Name + '</span></div>';
						html += '<div class="od_dj">';
						html += '<span>编码：<i>' + objs[i].Code + '</i></span>';
						html += '<span>等级：<i>' + objs[i].Grade + '</i></span>';
						html += '</div>';

						html += '<div class="od_dj">';
						html += '<span>颜色：<i>' + objs[i].Color + '</i></span><span>长度：<i>' + objs[i].Slength + '</i></span>';
						if (isForSale) {


							html += '</div><div class="od_dj"><span>包装：<i>' + objs[i].Packcount + '</i></span><span>可售：<i id="eid' +
								objs[i].Id + '">' + objs[i].Timelycount + '</i>' + objs[i].Unit + '</span>';
							html += '</div>';

							html += '<div class="od_dj od_littlefont">';
							html += '<span>正价：<i>' + objs[i].Price + '元/' + objs[i].Unit + '</i></span>';
							html += '<span><button loadUrl="product_details.html?id=' + objs[i].Id + '&site=' + objs[i].Ssite +
								'" type="button" class="mui-btn mui-btn-warning btn-detail" />查看详情</button>';
							html += '<button fid="' + objs[i].Loveid +
								'" type="button" class="mui-btn mui-btn-warning btn-cancel" />取消收藏</button></span>';
							html += '</div></div></div></a>';
							html +=
								'<div class="mui-collapse-content"><div class="mui-card"><div class="de_nowbuy"><div class="de_nowbuy_title">订购</div><div class="de_nowbuybox"><div class="de_xg"><span>数量：</span>';
							html +=
								'<div class="mui-numbox de_border" data-numbox-min="1"><button class="mui-btn mui-btn-numbox-minus" type="button">-</button>';
							html += '<input id="bc' + objs[i].Id +
								'" class="mui-input-numbox" type="number" /><button class="mui-btn mui-btn-numbox-plus" type="button">+</button>';
							html += '</div><button class="de_buybtn" name="btnDoOrder" onclick="doOrder(' + objs[i].Id +
								')">订购</button></div><div style="clear: both;"></div></div></div><div style="clear: both;"></div>';

							if (objs[i].Isbid == 1) {
								html +=
									'<div class="mui-collapse-content"><div class="de_nowbuy"><div class="de_nowbuy_title jg">竞购</div><div class="de_nowbuybox"><div class="de_xg"><span>价格：</span><input id="price' +
									objs[i].Id +
									'" class="mui-input-clear" type="text" data-input-clear="5" oninput="limitPrice(this)" data-floor="' + objs[
										i].Floorprice + '" /><span class="dj">底价：<i>' + objs[
										i]
									.Floorprice + '元/' + objs[i].Unit + '</i><span></div>';
								html +=
									'<div class="de_xg"><span>数量：</span><div class="mui-numbox de_border" data-numbox-min="1"><button class="mui-btn mui-btn-numbox-minus" type="button">-</button>';
								html += '<input id="bc2' + objs[i].Id +
									'" class="mui-input-numbox" type="number" /><button class="mui-btn mui-btn-numbox-plus" type="button">+</button>';
								html += '</div><button class="de_buybtn jg" name="btnBidOrder" onclick="bidOrder(' + objs[i].Id +
									')">竞购</button></div></div></div></div></div>';
							}

							html += '</li>';
						} else {
							html += '</div><div class="od_dj"><span>包装：<i>' + objs[i].Packcount + '</i></span><span>参考：<i>' + objs[i].Averprice +
								'元/' + objs[i].Unit + '</i>' + '</span>';
							html += '</div>';
							html += '<div class="od_dj od_littlefont">';
							html += '<span>最高：<i>' + objs[i].Maxcount + objs[i].Unit + '</i></span><span>最低：<i>' + objs[i].Mincount +
								objs[i].Unit + '</i></span>';
							html += '<span><button loadUrl="product_details.html?isForSale=0&id=' + objs[i].Bookid +
								'" type="button" class="mui-btn mui-btn-warning btn-detail" />详情</button>';
							html += '<button type="button" fid="' + objs[i].Loveid +
								'" class="mui-btn mui-btn-warning btn-cancel" />取消收藏</button</span>';
							html += '</div></div></div></a>';
							html +=
								'<div class="mui-collapse-content"><div class="mui-card"><div class="de_nowbuy"><div class="de_nowbuy_title">预订</div><div class="de_nowbuybox"><div class="de_xg"><span>数量：</span>';
							html +=
								'<div class="mui-numbox de_border" data-numbox-min="' + objs[i].Mincount +
								'"><button class="mui-btn mui-btn-numbox-minus" type="button">-</button>';
							html += '<input id="bb' + objs[i].Id +
								'" class="mui-input-numbox" type="number" /><button class="mui-btn mui-btn-numbox-plus" type="button">+</button>';
							html += '</div><button class="de_buybtn" name="btnBookOrder" onclick="bookOrder(' + objs[i].Id +
								')">预定</button></div><div style="clear: both;"></div></div></div>';
							html += '</div></div>';
						}
					}
					if (favorIndex > 1) {
						var oldHtml = document.getElementById("mylovelist").innerHTML;
						document.getElementById("mylovelist").innerHTML = oldHtml + html;
					} else {
						document.getElementById("mylovelist").innerHTML = html;
					}

					mui('.mui-numbox').numbox();
					mui('#mylovelist .od_littlefont').on('tap', '.btn-detail', function() {
						mui.openWindow(this.getAttribute("loadUrl") + "&isForSale=1&saleDate=" + saleDate);
						return false;
					});
					mui('#mylovelist .od_littlefont').on('tap', '.btn-cancel', function() {
						cancelFavor(this.getAttribute("fid"));
						return false;
					});
					mui.previewImage();
					favorIndex++;
				} else {
					if (isOtherSite) {
						favorIndex = 1;
						document.getElementById("mylovelist").innerHTML = '<li class="mui-table-view-cell">您暂无收藏的产品，快去收藏您的最爱吧？</li>';
					}
				}
			}
		});
	}
}

//设置菜单状态
function setMenuStatus() {
	if (color) {
		document.getElementById("btnColor").style.backgroundColor = "#eee";
	} else {
		document.getElementById("btnColor").style.backgroundColor = "#f7f7f7";
	}
	if (brand) {
		document.getElementById("btnBrand").style.backgroundColor = "#eee";
	} else {
		document.getElementById("btnBrand").style.backgroundColor = "#f7f7f7";
	}
	if (grade) {
		document.getElementById("btnGrade").style.backgroundColor = "#eee";
	} else {
		document.getElementById("btnGrade").style.backgroundColor = "#f7f7f7";
	}
	if (searchType == 1) {
		document.getElementById("btnNoPrice").style.backgroundColor = "#eee";
		document.getElementById("btnHasPrice").style.backgroundColor = "#f7f7f7";
		document.getElementById("btnUnBid").style.backgroundColor = "#f7f7f7";
	} else if (searchType == 2) {
		document.getElementById("btnNoPrice").style.backgroundColor = "#f7f7f7";
		document.getElementById("btnHasPrice").style.backgroundColor = "#eee";
		document.getElementById("btnUnBid").style.backgroundColor = "#f7f7f7";
	} else if (searchType == 3) {
		document.getElementById("btnNoPrice").style.backgroundColor = "#f7f7f7";
		document.getElementById("btnHasPrice").style.backgroundColor = "#f7f7f7";
		document.getElementById("btnUnBid").style.backgroundColor = "#eee";
	} else {
		document.getElementById("btnNoPrice").style.backgroundColor = "#f7f7f7";
		document.getElementById("btnHasPrice").style.backgroundColor = "#f7f7f7";
		document.getElementById("btnUnBid").style.backgroundColor = "#f7f7f7";
	}
}

//不选中分类
function blurType() {
	removeClass(divType, "mui-active");
	document.getElementById("btnType").style.backgroundColor = '#ecc080';
}

function search() {
	//设置菜单状态
	setMenuStatus();

	if (smallType && smallType.length > 0) {
		document.getElementById("h1title").innerHTML = smallType.join(',');
	} else if (bigType && bigType.length > 0) {
		document.getElementById("h1title").innerHTML = bigType.join(',');
	}
	blurType();
	mui('#middlePopover').popover('hide');
	mui('#topPopover').popover('hide');
	var ul = null;
	productList = []; //清空旧数据

	if (isForSale) {
		greenPageIndex = 1;
		ul = document.getElementById("ulgreenlist");
		ul.innerHTML = '';
		mui('#scroll1').scroll().scrollTo(0, 0, 100);
		loadPageData(smallType, bigType, 0, ul);
		addClass(divBuy, 'mui-active');
	} else {
		yellowPageIndex = 1;
		ul = document.getElementById("ulyellowlist");
		ul.innerHTML = '';
		mui('#scroll2').scroll().scrollTo(0, 0, 100); //重新初始化
		loadPageData(smallType, bigType, 1, ul);
		addClass(divBook, 'mui-active');
	}
	//重新加载收藏列表
	//initFavor();
}

//选择站点
function chooseSite(site, isFlag) {
	market = site;
	productList = [];
	window.localStorage.setItem('market', site);
	isFlag = isFlag;
	window.localStorage.setItem("isFlag", isFlag);
	document.getElementById("marketname").innerHTML = site;
	//搜索
	search();
	initFavor(true);
}

//重置参数
function resetParam() {
	localStorage.setItem('color', '');
	localStorage.setItem('brand', '');
	localStorage.setItem('grade', '');
	color = '';
	brand = '';
	grade = '';
}

//选择类型
function setSearchType(t) {
	searchType = t;
	//若为全部，则初始化颜色和品牌
	if (t == 0) {
		resetParam();
	}
	//搜索 
	search();
}

function doBook() {
	book();
	//设置为非在售
	isForSale = false;
	var startDate = null;
	var endDate = null;
	if (RDateUtil.formatDate(new Date(), "hh") < 11) {
		startDate = RDateUtil.addDate(new Date(), 3);
		endDate = RDateUtil.addDate(new Date(), 16);
	} else {
		startDate = RDateUtil.addDate(new Date(), 4);
		endDate = RDateUtil.addDate(new Date(), 17);
	}

	var picker = new mui.DtPicker({
		"type": "date",
		"beginDate": startDate,
		'endDate': endDate
	});
	picker.show(function(rs) {
		document.getElementById("h1Date").innerHTML = "(" + rs.text + ")";
		saleDate = rs.text;
		picker.dispose();
		//搜索
		search();
	});
}

function book() {
	//调整右上角功能框
	document.getElementById("liType1").style.display = 'none';
	document.getElementById("liType2").style.display = 'none';
	document.getElementById("liType3").style.display = 'none';
	document.getElementById("topPopover").style.height = '230px';
}

function updateUserInfo() {
	mui("#topPopover").popover('hide');
	initUserInfo();
}

var preDiv = "divBuy";

function initView() {
	document.getElementById("btnSearch").addEventListener('tap', function() {
		var strvalue = document.getElementById("searchvalue").value;
		if (strvalue == "") {
			mui.alert("编码或者品名不能为空", "提示")
		} else {
			var searchType = "";
			if (document.getElementById("divFavor").className.indexOf("mui-active") != -1) {
				searchType = "favor";
			}
			mui.openWindow("search.html?searchtext=" + strvalue + "&saleDate=" + saleDate + "&isForSale=" + isForSale +
				"&site=" + market + "&deposit=" + deposit + "&type=" + searchType);
		}
	});

	document.getElementById("marketname").innerHTML = market;
	//点击预订
	document.getElementById("btnBook").addEventListener('tap', function() {
		preDiv = "divBook";
		yellowPageIndex = 1;
		ul = document.getElementById("ulyellowlist");
		ul.innerHTML = '';
		doBook();

		document.getElementById("btnBuy").style.backgroundColor = '#fff';
		document.getElementById("btnBuy").style.color = '#91B57E';
		document.getElementById("btnBook").style.backgroundColor = '#B2B55E';
		document.getElementById("btnBook").style.color = '#fff';
		blurType();
	});
	//点击现售
	document.getElementById("btnBuy").addEventListener('tap', function() {
		preDiv = "divBuy";
		//设置为非在售
		isForSale = true;
		//调整右上角功能框
		document.getElementById("liType1").style.display = '';
		document.getElementById("liType2").style.display = '';
		document.getElementById("liType3").style.display = '';
		document.getElementById("topPopover").style.height = '362px';

		document.getElementById("btnBuy").style.backgroundColor = '#91B57E';
		document.getElementById("btnBuy").style.color = '#fff';
		document.getElementById("btnBook").style.backgroundColor = '#fff';
		document.getElementById("btnBook").style.color = '#B2B55E';
		blurType();

		saleDate = RDateUtil.formatDate((new Date()), "yyyy-MM-dd");
		document.getElementById("h1Date").innerHTML = "(" + saleDate + ")";
		// search()
		//搜索
		if (document.getElementById("ulgreenlist").innerHTML.trim() == "") {
			search();
		}
	});
	//点击分类
	document.getElementById("btnType").addEventListener('tap', function() {
		if (isForSale) {
			document.getElementById("btnBuy").style.backgroundColor = '#91B57E';
			document.getElementById("btnBuy").style.color = '#fff';
		} else {
			document.getElementById("btnBook").style.backgroundColor = '#B2B55E';
			document.getElementById("btnBook").style.color = '#fff';
		}
		if (divType.className.indexOf("mui-active") > -1) {
			removeClass(divType, "mui-active");
			document.getElementById("btnType").style.backgroundColor = '#ecc080';
			if (preDiv) {
				addClass(document.getElementById(preDiv), "mui-active");
			}
		} else {
			addClass(divType, "mui-active");
			document.getElementById("btnType").style.backgroundColor = '#f0ad4e';
		}
	});
	//点击收藏
	document.getElementById("btnFavor").addEventListener('tap', function() {
		if (this.className.indexOf("mui-active") > -1) {
			return;
		}
		preDiv = "divFavor";
		if (isForSale) {
			document.getElementById("btnBuy").style.backgroundColor = '#91B57E';
			document.getElementById("btnBuy").style.color = '#fff';
		} else {
			document.getElementById("btnBook").style.backgroundColor = '#B2B55E';
			document.getElementById("btnBook").style.color = '#fff';
		}
		blurType();
		initFavor(true);
	});

	//全部产品
	document.getElementById("btnSearchAll").addEventListener('tap', function() {
		document.getElementById("h1title").innerHTML = "全部";
		smallType = [];
		bigType = [];
		resetParam();
		removeClass(divType, 'mui-active');
		search();
	});

	//全部产品
	document.getElementById("btnMultiSearch").addEventListener('tap', function() {
		removeClass(divType, 'mui-active');
		search();
	});

	//选中多选
	mui('.multi-choice').on('change', 'input', function() {
		var value = this.checked ? true : false;
		isMultiSearch = value;
	});

	mui('#smallUlTypeList').on('tap', '.bigcateli', function() {
		var typeName = this.getAttribute("ptype");
		if (!isMultiSearch) {
			bigType = [];
			smallType = [];
			bigType.push(typeName);
			showSubTypeList(typeName);
			resetParam();
			removeClass(divType, 'mui-active');
			search();

		} else {
			if (this.className.indexOf("active") > -1) {
				removeClass(this, 'active');
				bigType = removeItem(bigType, typeName)
			} else {
				addClass(this, 'active');
				bigType = addItem(bigType, typeName);
			}
		}
	});
	mui('#smallUlTypeList').on('tap', '.samllcateli', function() {
		var typeName = this.getAttribute("ptype") + "_" + this.getAttribute("pclass");
		if (!isMultiSearch) {
			bigType = [];
			smallType = [];
			smallType.push(typeName);
			showSubTypeList(this.getAttribute("ptype"));
			resetParam();
			removeClass(divType, 'mui-active');
			search();
		} else {
			if (this.className.indexOf("active") > -1) {
				removeClass(this, 'active');
				smallType = removeItem(smallType, typeName)
			} else {
				addClass(this, 'active');
				smallType = addItem(smallType, typeName);
			}
		}
	});

	mui('.mui-scroll').on('tap', '.mui-input-numbox', function() {
		this.select();
	})

	mui.back = function() {
		var btnArray = ['是', '否'];
		mui.confirm('是否退出应用？', '缤纷鲜花', btnArray, function(e) {
			if (e.index == 0) {
				plus.runtime.quit();
			}
		})
	}
}

function initUserInfo() {
	var memCode = window.localStorage.getItem('memcode');
	if (memCode) {
		//获取余额
		$ajax(API_URL + '/Member/GetMemberByCode', {
			data: {
				memCode: memCode
			},
			dataType: 'json', //服务器返回json格式数据
			type: 'post', //HTTP请求类型
			timeout: 10000, //超时时间设置为10秒；
			success: function(data) {
				if (data && data.Member.Id > 0) {
					deposit = parseInt(data.Member.Deposit) || 25;
					document.getElementById("spanAmount").innerHTML = data.Member.Monetary.toFixed(2);
				}
			}
		});
	}
}

function initAllData() {
	initSite();
	initType();
	localStorage.setItem('color', '');
	localStorage.setItem('brand', '');
	localStorage.setItem('grade', '');

	initUserInfo();
}

if (IS_APP) {
	mui.plusReady(function() {
		if (isFlag == null) mui.openWindow('select_site.html');
		initView();
		initAllData();
	});
} else {
	if (isFlag == null) mui.openWindow('select_site.html');
	initView();
	initAllData();
}

//监听获取我的最爱
window.addEventListener('initFavor', function(e) {
	initFavor(true);
	var parent = plus.webview.currentWebview().opener();
	if (parent) {
		mui.fire(parent, 'initFavor');
	}
});

//监听设置颜色
window.addEventListener('setColor', function(e) {
	color = localStorage.getItem('color');
	//搜索 
	search();
	setMenuStatus();
});

//监听设置级别
window.addEventListener('setGrade', function(e) {
	grade = localStorage.getItem('grade');
	//搜索 
	search();
	setMenuStatus();
});

//监听设置品牌
window.addEventListener('setBrand', function(e) {
	brand = localStorage.getItem('brand');
	//搜索 
	search();
	setMenuStatus();
});

//监听更新数据
window.addEventListener('refreshProduct', function(e) {
	productList = [];
	search();
});
