var memcode = window.localStorage.getItem("memcode");
var txtStartDate = document.getElementById("starttime");
var txtEndDate = document.getElementById("endtime");

mui.init({
	swipeBack: false //启用右滑关闭功能
});

function initData() {
	if(memcode == "" || memcode == null) {
		mui.openWindow("login.html");
	}
	var date = new Date();
	var startDate = RDateUtil.addDate(date, -7);
	txtStartDate.value = RDateUtil.formatDate(startDate, "yyyy-MM-dd");
	txtEndDate.value = RDateUtil.formatDate(date, "yyyy-MM-dd");
	searchData();
}

function searchData() {

	if(txtStartDate.value == "") {
		mui.alert("请选择开始日期");
		return false;
	}
	if(txtEndDate.value == "") {
		mui.alert("请选择结束日期");
		return false;
	}
	$ajax(API_URL + '/Invoice/GetListByUserCode', {
		data: {
			startTime: txtStartDate.value,
			endTime: txtEndDate.value,
			memCode: memcode,
			pageSize: 1000
		},
		dataType: 'json', //服务器返回json格式数据
		type: 'get', //HTTP请求类型
		timeout: 10000, //超时时间设置为10秒；
		headers: {
			'Content-Type': 'application/json'
		},
		success: function(data) {
			var objs = data.Rows;
			var html = '';
			if(objs.length == 0) {
				html = '<li class="mui-table-view-cell">没有找到相关信息！</li>';
			} else {
				for(var i = 0; i < objs.length; i++) {
					html += '<li class="mui-table-view-cell"><a class="mui-navigate-right" href="shipping_detail.html?id=' +
						objs[i].Id + '">' + objs[i].Saledate + '<span>发货方式：' + objs[i].Logisticstype + '</span></a></li>';
				}
			}
			document.getElementById("spanTotal").innerHTML = data.Total;
			document.getElementById("ulShipping").innerHTML = html;
		}
	})
}

function initView() {
	var btns = mui('.my-text');
	btns.each(function(i, btn) {
		btn.addEventListener('tap', function() {
			var _self = this;
			if(_self.picker) {
				_self.picker.show(function(rs) {
					if(id == "starttime") {
						txtStartDate.value = rs.text;
					} else {
						txtEndDate.value = rs.text;
					}
					_self.picker.dispose();
					_self.picker = null;
				});
			} else {
				var optionsJson = this.getAttribute('data-options') || '{}';
				var options = JSON.parse(optionsJson);
				var id = this.getAttribute('id');

				_self.picker = new mui.DtPicker(options);
				_self.picker.show(function(rs) {

					if(id == "starttime") {
						txtStartDate.value = rs.text;
					} else {
						txtEndDate.value = rs.text;
					}
					_self.picker.dispose();
					_self.picker = null;
				});
			}

		}, false);
	});

	mui('body').on('tap', 'a', function() {
		mui.openWindow(this.href);
	});

	document.getElementById("btnsearch").addEventListener('tap', function() {
		searchData();
	});
}

if(IS_APP) {
	mui.plusReady(function() {
		initView();
		initData();
	});
} else {
	initView();
	initData();
}